CSAnimation = CSAnimation or class()
function CSAnimation:SetAlpha(o, alpha)
    local t = o:alpha()
    if t > alpha then
        while t > alpha do
            t = t - coroutine.yield()
            o:set_alpha(t)
        end
    else
        while t < alpha do
            t = t + coroutine.yield()
            o:set_alpha(t)
        end
    end
    o:set_alpha(alpha)
end

function CSAnimation:Flash(o, times)
    times = times or 1
    local t
    for i = 1, times, 1 do
        t = 0.5
        o:set_alpha(1)
        while t > 0 do -- Start (Fully visible)
            t = t - coroutine.yield()
            o:set_alpha(math.sin(t * 180))
        end
        o:set_alpha(0)
        t = 0
        while t < 0.5 do -- End (Not visible at all)
            t = t + coroutine.yield()
            o:set_alpha(math.sin(t * 180))
        end
    end
    o:set_alpha(1)
end