-- Main Menu
function CSHUDMenu:SetCS2(cs2, hud)
    hud = hud or self:GetMenu("csgo_section_hud_menu")
    local items =
    {
        csgo_panel_bg_alpha_choice = true,
        csgo_hud_avatar_time_panel_position_choice = true,
        health_armor_style = true
    }
    for _, item in ipairs(hud.items or {}) do
        if items[item.id] then
            self:AnimateItemEnabled(item, not cs2)
        end
    end
end

function CSHUDMenu:SetHUDColor(color)
    local c = CSHUD.settings.hud_color
    c.r = color.red
    c.g = color.green
    c.b = color.blue
end

function CSHUDMenu:SetOption(value, option)
    CSHUD.settings[option] = value
end

function CSHUDMenu:SetCSHUD(value)
    CSHUD.settings.cs_hud = value
    self:SetCS2(value)
end

function CSHUDMenu:SetWeaponSkin(value)
    CSHUD.settings.weapon_skin = value
end

function CSHUDMenu:SetAvatarTimePanelPosition(value)
    CSHUD.settings.avatar_time_panel_position = value
end

function CSHUDMenu:SetFormatValues(value)
    CSHUD.settings.format_values = value
end

function CSHUDMenu:SetBotAvatar(value)
    CSHUD.settings.bot_avatar = value
end

function CSHUDMenu:SetPanelBGAlpha(value)
    CSHUD.settings.panel_bg_alpha = value
end

function CSHUDMenu:SetRandomPositionOnHUD(value)
    CSHUD.settings.random_position_on_hud = value
end

function CSHUDMenu:SetHealthArmorStyle(value)
    CSHUD.settings.health_armor_style = value
end

function CSHUDMenu:SetSounds(value)
    CSHUD.settings.play_sounds = value
end

function CSHUDMenu:SetHUDEdgePositionX(value)
    CSHUD:Log("Value X: " .. value)
    CSHUD.settings.hud_edge_position_x = value
end

function CSHUDMenu:SetHUDEdgePositionY(value)
    CSHUD:Log("Value Y: " .. value)
    CSHUD.settings.hud_edge_position_y = value
end

function CSHUDMenu:SetHideAvatarImages(value)
    CSHUD.settings.hide_avatar_images = value
end

function CSHUDMenu:HUDMenuCreatedCallback(menu)
    if CSHUD:GetOption("cs_hud") == 1 then
        self:SetCS2(true, menu)
    end
end

-- Components
function CSHUDMenu:SetComponent(value, option)
    CSHUD.settings.components[option] = value
end

-- Mod Option
function CSHUDMenu:SetModOption(value, mod, option)
    CSHUD.settings.mod[mod][option] = value
end