local _f_init = EnemyManager.init
function EnemyManager:init()
    _f_init(self)

    self._csgo = CSHUD:CreatePanel("csgo_enemy")

    self._csgo:hide()

    local panel_h = self._csgo:h()
    local level_id = Global.game_settings.level_id
    local player_faction = (level_id == "mad" or level_id == "bph") and "ct" or "t"
    local enemy_faction = (level_id == "mad" or level_id == "bph") and "t" or "ct"
    local top, y = nil, nil
    if CSHUD:GetOption("cs_hud") == 1 then
        top = true
        y = 2
    else
        top = CSHUD:GetOption("avatar_time_panel_position") == 1
        y = CSHUD:ComputeEdgeY(panel_h, top and 2 or (panel_h - 48))
    end
    self.enemy_color = tweak_data.csgo.colors[enemy_faction]
    self.enemies = self._csgo:panel({
        name = "enemies",
        x = 678 + CSHUD:ReturnResXDifferenceAbove1920(),
        y = y,
        w = 44,
        h = 44,
        visible = level_id ~= "chill" -- Safehouse
    })
    local enemy = self.enemies:bitmap({
        name = "enemy",
        texture = tweak_data.csgo.textures.faction.texture,
        texture_rect = tweak_data.csgo.textures.faction[enemy_faction].square,
        layer = 12,
        w = 40,
        h = 40,
        x = 2,
        y = 2
    })
    self.enemy_text = self.enemies:text({
        text = "0",
        name = "enemy_text",
        align = "center",
        vertical = "center",
        font_size = tweak_data.csgo.fonts.numbers.font_size,
        font = tweak_data.csgo.fonts.numbers.font,
        blend_mode = "normal",
        layer = 15,
        color = Color.white,
        w = 40,
        h = 40,
        x = 2,
        y = 2
    })
    local enemy_alive_text = self.enemies:text({
        text = managers.localization:text("hud_alive"),
        name = "enemy_alive_text",
        align = "center",
        vertical = "center",
        font_size = 12,
        font = tweak_data.csgo.fonts.verdana.font,
        blend_mode = "normal",
        layer = 15,
        color = Color.white,
        w = 40,
        h = 40
    })
    local _, _, w, h = enemy_alive_text:text_rect()

	enemy_alive_text:set_size(w, h)
	enemy_alive_text:set_position(math.round(enemy_alive_text:x()), math.round(enemy_alive_text:y()))
    enemy_alive_text:set_y(30)
    enemy_alive_text:set_center_x(self.enemy_text:center_x())
    self.enemies:bitmap({
        name = "enemy_frame",
        texture = tweak_data.csgo.textures.frame,
        layer = 12,
        w = 44,
        h = 44,
        x = 0,
        y = 0,
        color = self.enemy_color
    })

    -- Total alive players
    self.total_players = self._csgo:panel({
        name = "total_players",
        x = 558 + CSHUD:ReturnResXDifferenceAbove1920(),
        y = y,
        w = 44,
        h = 44,
        visible = level_id ~= "chill" and HUDManager.BigLobby -- Safehouse and BigLobby mod
    })
    self.alive_players = 0
    local players = self.total_players:bitmap({
        name = "players",
        texture = tweak_data.csgo.textures.faction.texture,
        texture_rect = tweak_data.csgo.textures.faction[player_faction].square,
        layer = 12,
        w = 40,
        h = 40,
        x = 2,
        y = 2
    })
    self.player_text = self.total_players:text({
        text = "0",
        name = "player_text",
        align = "center",
        vertical = "center",
        font_size = tweak_data.csgo.fonts.numbers.font_size,
        font = tweak_data.csgo.fonts.numbers.font,
        blend_mode = "normal",
        layer = 15,
        color = Color.white,
        w = 40,
        h = 40,
        x = 2,
        y = 2
    })
    local player_alive_text = self.total_players:text({
        text = managers.localization:text("hud_alive"),
        name = "player_alive_text",
        align = "center",
        vertical = "center",
        font_size = 12,
        font = tweak_data.menu.pd2_large_font,
        blend_mode = "normal",
        layer = 15,
        color = Color.white,
        w = 40,
        h = 40
    })
    local _, _, w, h = player_alive_text:text_rect()

	player_alive_text:set_size(w, h)
	player_alive_text:set_position(math.round(player_alive_text:x()), math.round(player_alive_text:y()))
    player_alive_text:set_y(30)
    player_alive_text:set_center_x(self.enemy_text:center_x())
    self.total_players:bitmap({
        name = "player_frame",
        texture = tweak_data.csgo.textures.frame,
        layer = 12,
        w = 44,
        h = 44,
        x = 0,
        y = 0,
        color = tweak_data.csgo.colors[player_faction]
    })
end

local _f_on_enemy_registered = EnemyManager.on_enemy_registered
function EnemyManager:on_enemy_registered(unit)
    _f_on_enemy_registered(self, unit)
    self.enemy_text:set_text(self._enemy_data.nr_units)
end

local _f_on_enemy_unregistered = EnemyManager.on_enemy_unregistered
function EnemyManager:on_enemy_unregistered(unit)
    _f_on_enemy_unregistered(self, unit)
    self.enemy_text:set_text(self._enemy_data.nr_units)
end

function EnemyManager:on_player_registered()
    self.alive_players = self.alive_players + 1
    self.player_text:set_text(self.alive_players)
end

function EnemyManager:on_player_unregistered()
    self.alive_players = self.alive_players - 1
    self.player_text:set_text(self.alive_players)
end

function EnemyManager:set_buff_enabled(buff_name, enabled)
    if enabled then
        self.enemies:child("enemy_frame"):set_color(Color(1, 1, 0.5019607843137255, 0))
    else
        self.enemies:child("enemy_frame"):set_color(self.enemy_color)
    end
end

if CSHUD:IsKillfeedEnabled() then
    local on_enemy_died = EnemyManager.on_enemy_died
    function EnemyManager:on_enemy_died(unit, damage_info, ...)
        on_enemy_died(self, unit, damage_info, ...)
        if unit:base():has_tag("special") then
            managers.hud:AddFeedToKillFeed(unit, unit:base()._tweak_table, unit:base()._stats_name, damage_info)
        end
    end
end