if CSHUD:IsVROrComponentIsDisabled("gage") then
	return
end

local function MakeFineText(text)
	local x, y, w, h = text:text_rect()

	text:set_size(w, h)
	text:set_position(math.round(text:x()), math.round(text:y()))
end

function GageAssignmentManager:CreatePanel()
	local panel_color = CSHUD:GetColorFromTable(CSHUD.settings.hud_color)
	self._panel = CSHUD:CreatePanel("gage")
	self._gage = self._panel:panel({
		name = "gage",
		w = 313,
		h = 50,
		x = -313,
		y = (self._panel:h() - 50) / 2,
		visible = true
	})
	local bg = self._gage:bitmap({
		name = "bg",
		texture = "guis/textures/pd2_hud_cs/waiting_teammate_bg",
		layer = -1
	})
	local gage_icon = self._gage:bitmap({
		name = "icon",
		texture = "guis/dlcs/gage_pack_jobs/textures/pd2/endscreen/gage_assignment",
		blend_mode = "add",
		w = 32,
		h = 32,
		x = 5,
		y = (self._gage:h() - 32) / 2
	})
	local completed = self._gage:bitmap({
		name = "completed",
		texture = "guis/textures/pd2_hud_cs/checkbox",
		w = 20,
		h = 20,
		y = 20,
		visible = false,
		color = panel_color
	})
	completed:set_left(gage_icon:right() + 5)
	local picked_up = self._gage:text({
		name = "picked_up",
		font = tweak_data.csgo.fonts.numbers.font,
		font_size = 20,
		text = "00",
		align = "right",
		color = panel_color,
		y = 20
	})
	MakeFineText(picked_up)
	picked_up:set_left(completed:right())
	local separator = self._gage:text({
		name = "separator",
		font = tweak_data.csgo.fonts.numbers.font,
		font_size = 15,
		text = "/",
		color = panel_color
	})
	picked_up:set_text("0")
	MakeFineText(separator)
	separator:set_left(picked_up:right() + 1)
	separator:set_bottom(picked_up:bottom())
	local total = self._gage:text({
		name = "total",
		font = tweak_data.csgo.fonts.numbers.font,
		font_size = 13,
		text = tostring(self:count_all_units()),
		color = panel_color
	})
	MakeFineText(total)
	total:set_left(separator:right())
	total:set_bottom(picked_up:bottom())
	local objective = self._gage:text({
		name = "objective",
		font = tweak_data.menu.pd2_large_font,
		font_size = 15,
		text = "Find Gage packages",
		color = panel_color,
		y = 3
	})
	MakeFineText(objective)
	objective:set_left(gage_icon:right() + 5)
	picked_up:set_y(22)
	total:set_y(25)
end

function GageAssignmentManager:present_progress(assignment, peer_name)
	local panel = self._gage
	panel:stop()
	panel:animate(callback(self, self, "Animate"))
end

function GageAssignmentManager:Animate(o)
	local max_units = self:count_all_units()
	local remaining = self:count_active_units() - 1
	o:child("picked_up"):set_text((max_units - remaining))
	local stinger = "stinger_feedback_positive"
	if remaining == 0 then
		o:child("completed"):set_visible(true)
		stinger = "Achievement_challenge"
	end
	if managers.hud and managers.hud._sound_source then
		managers.hud._sound_source:post_event(stinger)
	end
	local TOTAL_T = 0.18
	local OFFSET = 1
	local from_x = -313
	local target_x = 0
	local t_max = 0.04
	local t = (1 - math.abs(o:x() - target_x) / OFFSET) * 0.12
	t = math.lerp(t_max, 0, ((o:x() + 313) / 313))
	while TOTAL_T > t do
		local dt = coroutine.yield()
		t = math.min(t + dt, TOTAL_T)
		local lerp = t / TOTAL_T

		o:set_x(math.lerp(from_x, target_x, lerp))
	end

	wait(3)

	t = t_max

	while TOTAL_T > t do
		local dt = coroutine.yield()
		t = math.min(t + dt, TOTAL_T)
		local lerp = t / TOTAL_T

		o:set_x(math.lerp(target_x, from_x, lerp))
	end
end