local CSHUD = CSHUD
if CSHUD._hooks.GroupAIStateBase then
    return
else
    CSHUD._hooks.GroupAIStateBase = true
end
local original =
{
    set_unit_teamAI = GroupAIStateBase.set_unit_teamAI,
    set_point_of_no_return_timer = GroupAIStateBase.set_point_of_no_return_timer
}
function GroupAIStateBase:set_unit_teamAI(unit, character_name, team_id, visual_seed, loadout, ...)
    original.set_unit_teamAI(self, unit, character_name, team_id, visual_seed, loadout, ...)
    local character = managers.criminals:character_by_name(character_name)

    if not character then
        return
    end

    local panel = character.data.panel_id

    unit:character_damage():SetPanel(panel)
    unit:movement():SetPanel(panel)

    if not managers.hud then
        return
    end

    managers.hud:CustodyTeammatePanels_SetWeapons(panel, nil, true, { loadout = loadout, character = character_name })
    managers.hud:SetStatsScreenAIPerk(panel, loadout)
end

function GroupAIStateBase:set_point_of_no_return_timer(...)
    original.set_point_of_no_return_timer(self, ...)
    if self._point_of_no_return_timer then
        managers.hud:ShowBombMessage(self._point_of_no_return_timer)
    end
end

if not CSHUD:IsKillfeedEnabled() then
    return
end

original.convert_hostage_to_criminal = GroupAIStateBase.convert_hostage_to_criminal
function GroupAIStateBase:convert_hostage_to_criminal(unit, peer_unit, ...)
    original.convert_hostage_to_criminal(self, unit, peer_unit, ...)
    if unit:brain()._logic_data.is_converted then
        local player_unit = peer_unit or managers.player:player_unit()
        managers.hud:AddFeedToKillFeed(unit, unit:base()._tweak_table, unit:base()._tweak_table, { attacker_unit = player_unit, variant = "convert" })
    end
end

original.sync_converted_enemy = GroupAIStateBase.sync_converted_enemy
function GroupAIStateBase:sync_converted_enemy(converted_enemy, owner_peer_id, ...)
    if owner_peer_id then
        local unit = managers.network:session():peer(owner_peer_id):unit()
        managers.hud:AddFeedToKillFeed(converted_enemy, converted_enemy:base()._tweak_table, converted_enemy:base()._tweak_table, { attacker_unit = unit, variant = "convert" })
    end
    return original.sync_converted_enemy(self, converted_enemy, owner_peer_id, ...)
end