if not CSHUD:GetComponentOption("assault_panel") then
    return
end

local original =
{
    init = HUDAssaultCorner.init
}

function HUDAssaultCorner:init(hud, full_hud, tweak_hud)
	original.init(self, hud, full_hud, tweak_hud)
	-- Why should I always call is_active/is_skirmish function every time when the status changes only when reloading a level ?
	self._is_crimespree = managers.crime_spree and managers.crime_spree:is_active()
	self._is_skirmish = managers.skirmish and managers.skirmish:is_skirmish()
	local textures = tweak_data.csgo.textures.assault_panel
	local assault_panel_texture = textures.texture
	local wh = 32
	-- Assault Panel
    local assault_panel = self._hud_panel:child("assault_panel")
	local icon_assaultbox = assault_panel:child("icon_assaultbox")
    icon_assaultbox:set_w(wh)
	icon_assaultbox:set_h(wh)
	icon_assaultbox:set_image(assault_panel_texture, unpack(textures.assault))
	self._bg_box:set_visible(false)
	assault_panel:set_w(assault_panel:w() * 2)
    assault_panel:child("yellow_tape"):set_visible(false)
    assault_panel:remove(assault_panel:child("text_panel"))
    local text_panel = assault_panel:text({
		layer = 1,
		name = "text_panel",
		text = "POLICE ASSAULT IN PROGRESS",
		font_size = tweak_data.hud_corner.assault_size,
		font = tweak_data.hud_corner.assault_font,
		y = 4,
		alpha = 0,
		blend_mode = "add"
    })
    assault_panel:set_right(self._hud_panel:w())
	icon_assaultbox:set_right(icon_assaultbox:parent():w())
	self._text_offset = wh + 5
	text_panel:set_right(assault_panel:w() - self._text_offset)
	-- Assault Panel

	-- Casing Panel
	local casing_panel = self._hud_panel:child("casing_panel")
	local icon_casing = casing_panel:child("icon_casingbox")
	icon_casing:set_w(wh)
	icon_casing:set_h(wh)
	icon_casing:set_image(assault_panel_texture, unpack(textures.stealth))
	self._casing_bg_box:set_visible(false)
	casing_panel:set_w(casing_panel:w() * 2)
	casing_panel:remove(casing_panel:child("text_panel"))
	local text_casing = casing_panel:text({
		layer = 1,
		name = "text_panel",
		text = "MASK UP",
		font_size = tweak_data.hud_corner.assault_size,
		font = tweak_data.hud_corner.assault_font,
		y = 4,
		alpha = 0,
		blend_mode = "add",
		color = self._casing_color
	})
	casing_panel:set_right(self._hud_panel:w())
	icon_casing:set_right(icon_casing:parent():w())
	text_casing:set_right(casing_panel:w() - self._text_offset)
	-- Casing Panel

	-- No Return Panel
	local no_return_panel = self._hud_panel:child("point_of_no_return_panel")
	local icon_noreturn = no_return_panel:child("icon_noreturnbox")
	icon_noreturn:set_w(wh)
	icon_noreturn:set_h(wh)
	icon_noreturn:set_image(assault_panel_texture, unpack(textures.noreturn))
	self._noreturn_bg_box:set_visible(false)
	no_return_panel:set_w(no_return_panel:w() * 2)
	local no_return_time = no_return_panel:text({
		layer = 1,
		name = "noreturn_time",
		text = "00:00",
		font_size = tweak_data.hud_corner.assault_size * 1.25,
		font = tweak_data.hud_corner.assault_font,
		y = 4,
		alpha = 0,
		blend_mode = "add",
		color = self._noreturn_color
	})
	managers.hud:make_fine_text(no_return_time)
	no_return_panel:set_right(self._hud_panel:w())
	icon_noreturn:set_right(icon_noreturn:parent():w())
	no_return_time:set_right(no_return_panel:w() - self._text_offset - 5)
	local no_return_text = no_return_panel:text({
		layer = 1,
		name = "noreturn_text",
		text = utf8.to_upper(managers.localization:text(self._noreturn_data.text_id, { time = "" })),
		font_size = tweak_data.hud_corner.assault_size,
		font = tweak_data.hud_corner.assault_font,
		y = 4,
		alpha = 0,
		blend_mode = "add",
		color = self._noreturn_color
	})
	managers.hud:make_fine_text(no_return_text)
	no_return_text:set_right(no_return_panel:w() - no_return_time:w() - self._text_offset - 10)
	no_return_time:set_font_size(tweak_data.hud_corner.assault_size)
	-- No Return Panel
end

function HUDAssaultCorner:_set_text_list(text_list)
    self._text_list = text_list or {""}
end

function HUDAssaultCorner:_get_assault_strings()
	if self._assault_mode == "normal" then
		if managers.job:current_difficulty_stars() > 0 then
			local ids_risk = Idstring("risk")
			return {
				"hud_assault_assault",
				ids_risk,
				"hud_assault_assault",
				ids_risk,
			}
		else
			return {
				"hud_assault_assault",
				"hud_assault_assault",
				"hud_assault_assault",
			}
		end
	else
		if managers.job:current_difficulty_stars() > 0 then
			local ids_risk = Idstring("risk")
			return {
				"hud_assault_vip",
				ids_risk,
				"hud_assault_vip",
				ids_risk,
			}
		else
			return {
				"hud_assault_vip",
				"hud_assault_vip",
				"hud_assault_vip"
			}
		end
	end
end

function HUDAssaultCorner:_get_survived_assault_strings()
	if managers.job:current_difficulty_stars() > 0 then
		local ids_risk = Idstring("risk")
		return {
			"hud_assault_survived",
			ids_risk,
			"hud_assault_survived",
			ids_risk
		}
	else
		return {
			"hud_assault_survived",
			"hud_assault_survived",
			"hud_assault_survived"
		}
	end
end

function HUDAssaultCorner:_start_assault(text_list)
	local assault_panel = self._hud_panel:child("assault_panel")
	local text_panel = assault_panel:child("text_panel")

	self:_set_text_list(text_list or {""})

	local started_now = not self._assault
	self._assault = true

    assault_panel:stop()
	assault_panel:set_visible(true)

	local icon_assaultbox = assault_panel:child("icon_assaultbox")

	icon_assaultbox:stop()
	icon_assaultbox:animate(callback(self, self, "_show_icon_assaultbox"))

	text_panel:stop()
	text_panel:animate(callback(self, self, "_animate_text"), assault_panel, nil, callback(self, self, "assault_attention_color_function"))
	self:_set_feedback_color(self._assault_color)

	if alive(self._wave_bg_box) then
		self._wave_bg_box:stop()
		self._wave_bg_box:animate(callback(self, self, "_animate_wave_started"), self)
	end

	if self._is_skirmish and started_now then
		self:_popup_wave_started()
	end
end

function HUDAssaultCorner:_animate_text(text_panel, assault_panel, color, color_function)
	local text_index = 1
	text_panel:set_alpha(0)
	while true do
		local text = nil
		if not self._text_list[text_index] then
			text_index = 1
		end
		text = self._text_list[text_index]
		local text_string = ""
		if type(text) == "string" then
			text_string = managers.localization:to_upper_text(text)
		elseif text == Idstring("risk") then
			if self._is_crimespree then
				text_string = managers.localization:to_upper_text("menu_cs_level", {
					level = managers.experience:cash_string(managers.crime_spree:server_spree_level(), "")
				})
			else
				for i = 1, managers.job:current_difficulty_stars() do
					text_string = text_string .. managers.localization:get_default_macro("BTN_SKULL")
				end
			end
		end
		text_panel:set_text(text_string)
		managers.hud:make_fine_text(text_panel)
		text_panel:set_right(assault_panel:w() - self._text_offset)
		local mod_color = color_function and color_function() or color or self._assault_color
		text_panel:set_color(mod_color)
        --[[local text = text_panel:text({
			vertical = "center",
			h = 10,
			w = 10,
			align = "center",
			blend_mode = "add",
			layer = 1,
			text = text_string,
			color = mod_color,
			font_size = tweak_data.hud_corner.assault_size,
			font = tweak_data.hud_corner.assault_font
		})]]
		--
		-- Animate alpha
		local dt = 0
		text_panel:set_alpha(0)
		while dt < 1 do
			dt = dt + coroutine.yield()
			text_panel:set_alpha(dt)
		end
		text_panel:set_alpha(1)
		wait(3)
		dt = 1
		while dt > 0 do
			dt = dt - coroutine.yield()
			text_panel:set_alpha(dt)
		end
		text_panel:set_alpha(0)
        --[[for i = 1, 5, 1 do
            t = 0.5
            text_panel:set_alpha(1)
            while t > 0 do
                t = t - coroutine.yield()
                text_panel:set_alpha(math.sin(t * 180))
            end
            text_panel:set_alpha(0)
            t = 0
            while t < 0.5 do
                t = t + coroutine.yield()
                text_panel:set_alpha(math.sin(t * 180))
            end
        end
        text_panel:set_alpha(1)]]
		-- increment index
		text_index = text_index + 1
    end
end

function HUDAssaultCorner:sync_set_assault_mode(mode)
	if self._assault_mode == mode then
		return
	end

	self._assault_mode = mode
	local color = self._assault_color

	if mode == "phalanx" then
		color = self._vip_assault_color
	end

	self:_update_assault_hud_color(color)
	self:_set_text_list(self:_get_assault_strings())

	local assault_panel = self._hud_panel:child("assault_panel")
	local icon_assaultbox = assault_panel:child("icon_assaultbox")
	local texture, texture_rect
	if mode == "phalanx" then
		texture = "guis/textures/pd2/hud_icon_padlockbox"
		texture_rect = {0, 0, 32, 32}
	else
		texture = tweak_data.csgo.textures.assault_panel.texture
		texture_rect = tweak_data.csgo.textures.assault_panel.assault
	end

	icon_assaultbox:set_image(texture, unpack(texture_rect))
end

function HUDAssaultCorner:_update_assault_hud_color(color)
	self._current_assault_color = color
	local assault_panel = self._hud_panel:child("assault_panel")
	assault_panel:child("icon_assaultbox"):set_color(color)
	assault_panel:child("text_panel"):set_color(color)
end

function HUDAssaultCorner:_show_icon_assaultbox(icon_assaultbox)
	local t = 0
	while t < 1 do
		t = t + coroutine.yield()
		icon_assaultbox:set_alpha(t)
	end
	icon_assaultbox:set_alpha(1)
end

function HUDAssaultCorner:_hide_icon_assaultbox(icon_assaultbox)
	local t = 1
	while t > 0 do
		t = t - coroutine.yield()
		icon_assaultbox:set_alpha(t)
		if self._remove_hostage_offset and t < 0.3 then
			self:_set_hostage_offseted(false)
		end
	end

	if self._remove_hostage_offset then
		self:_set_hostage_offseted(false)
	end

	icon_assaultbox:set_alpha(0)

	if not self._casing then
		self:_show_hostages()
	end
end

function HUDAssaultCorner:_end_assault()
	if not self._assault then
		self._start_assault_after_hostage_offset = nil

		return
	end

	self:_set_feedback_color(nil)

	self._assault = false

	self._remove_hostage_offset = true
	self._start_assault_after_hostage_offset = nil
	local assault_panel = self._hud_panel:child("assault_panel")
	local icon_assaultbox = assault_panel:child("icon_assaultbox")
	local text_panel = assault_panel:child("text_panel")

	icon_assaultbox:stop()

	if self:should_display_waves() then
		self:_update_assault_hud_color(self._assault_survived_color)
		self:_set_text_list(self:_get_survived_assault_strings())
		text_panel:stop()
		text_panel:animate(callback(self, self, "_animate_text"), assault_panel, nil, callback(self, self, "assault_attention_color_function"))
		icon_assaultbox:stop()
		icon_assaultbox:animate(callback(self, self, "_show_icon_assaultbox"))
		self._wave_bg_box:stop()
		self._wave_bg_box:animate(callback(self, self, "_animate_wave_completed"), self)

		if self._is_skirmish then
			self:_popup_wave_finished()
		end
	else
		self:_close_assault_box()
	end
end

function HUDAssaultCorner:_close_assault_box()
	local assault_panel = self._hud_panel:child("assault_panel")
	local icon_assaultbox = assault_panel:child("icon_assaultbox")
	local text_panel = assault_panel:child("text_panel")

	icon_assaultbox:stop()
	icon_assaultbox:animate(callback(self, self, "_hide_icon_assaultbox"))

	text_panel:stop()
	text_panel:animate(callback(CSAnimation, CSAnimation, "SetAlpha"), 0)
end

function HUDAssaultCorner:show_casing(mode)
	self:_end_assault()

	local casing_panel = self._hud_panel:child("casing_panel")
	local text_panel = casing_panel:child("text_panel")
	local msg = nil

	if mode == "civilian" then
		msg = "hud_casing_mode_ticker_clean"
	else
		msg = "hud_casing_mode_ticker"
	end

	text_panel:set_text(managers.localization:to_upper_text(msg))
	managers.hud:make_fine_text(text_panel)
	text_panel:set_right(casing_panel:w() - self._text_offset)

	self:_hide_hostages()
	casing_panel:stop()
	casing_panel:set_visible(true)
	casing_panel:animate(callback(self, self, "_show_icon_assaultbox"))
	text_panel:stop()
	text_panel:animate(callback(CSAnimation, CSAnimation, "SetAlpha"), 1)

	self._casing = true
end

function HUDAssaultCorner:hide_casing()
	local panel = self._hud_panel:child("casing_panel")
	local icon_casingbox = panel:child("icon_casingbox")

	icon_casingbox:stop()
	icon_casingbox:animate(callback(self, self, "_hide_icon_assaultbox"))

	panel:child("text_panel"):stop()
	panel:child("text_panel"):animate(callback(CSAnimation, CSAnimation, "SetAlpha"), 0)

	self._casing = false
end

function HUDAssaultCorner:feed_point_of_no_return_timer(time, is_inside)
	time = math.floor(time)
	local minutes = math.floor(time / 60)
	local seconds = math.round(time - minutes * 60)
	local text = (minutes < 10 and "0" .. minutes or minutes) .. ":" .. (seconds < 10 and "0" .. seconds or seconds)

	self._hud_panel:child("point_of_no_return_panel"):child("noreturn_time"):set_text(text)
end

function HUDAssaultCorner:show_point_of_no_return_timer(id)
	local delay_time = self._assault and 1.2 or 0

	self:_end_assault()
	self:_update_noreturn(id)

	local point_of_no_return_panel = self._hud_panel:child("point_of_no_return_panel")

	self:_hide_hostages()
	point_of_no_return_panel:stop()
	point_of_no_return_panel:animate(callback(self, self, "_animate_show_noreturn"), delay_time)
	self:_set_feedback_color(self._noreturn_color)

	self._point_of_no_return = true
end

function HUDAssaultCorner:hide_point_of_no_return_timer()
	local point_of_no_return_panel = self._hud_panel:child("point_of_no_return_panel")
	point_of_no_return_panel:stop()
	point_of_no_return_panel:set_visible(false)
	point_of_no_return_panel:child("noreturn_text"):stop()
	point_of_no_return_panel:child("noreturn_text"):set_visible(false)
	point_of_no_return_panel:child("noreturn_time"):stop()
	point_of_no_return_panel:child("noreturn_time"):set_visible(false)
	self._point_of_no_return = false

	self:_show_hostages()
	self:_set_feedback_color(nil)
end

function HUDAssaultCorner:_animate_show_noreturn(point_of_no_return_panel, delay_time)
	local icon_noreturnbox = point_of_no_return_panel:child("icon_noreturnbox")
	local point_of_no_return_text = point_of_no_return_panel:child("noreturn_text")

	point_of_no_return_text:set_visible(false)

	local point_of_no_return_timer = point_of_no_return_panel:child("noreturn_time")

	point_of_no_return_timer:set_visible(false)
	wait(delay_time)
	point_of_no_return_panel:set_visible(true)
	icon_noreturnbox:stop()
	icon_noreturnbox:animate(callback(self, self, "_show_icon_assaultbox"))

	point_of_no_return_timer:set_visible(true)
	point_of_no_return_timer:stop()
	point_of_no_return_timer:animate(callback(CSAnimation, CSAnimation, "SetAlpha"), 1)

	point_of_no_return_text:set_visible(true)
	point_of_no_return_text:stop()
	point_of_no_return_text:animate(callback(CSAnimation, CSAnimation, "SetAlpha"), 1)
end

function HUDAssaultCorner:flash_point_of_no_return_timer(beep)
	local function flash_timer(o)
		local t = 0

		while t < 0.5 do
			t = t + coroutine.yield()
			local n = 1 - math.sin(t * 180)
			local r = math.lerp(1 or self._point_of_no_return_color.r, 1, n)
			local g = math.lerp(0 or self._point_of_no_return_color.g, 0.8, n)
			local b = math.lerp(0 or self._point_of_no_return_color.b, 0.2, n)

			o:set_color(Color(r, g, b))
			o:set_font_size(math.lerp(tweak_data.hud_corner.noreturn_size, tweak_data.hud_corner.noreturn_size * 1.25, n))
		end
	end

	local point_of_no_return_timer = self._hud_panel:child("point_of_no_return_panel"):child("noreturn_time")

	point_of_no_return_timer:animate(flash_timer)
end

function HUDAssaultCorner:_update_noreturn(id)
	local point_of_no_return_panel = self._hud_panel:child("point_of_no_return_panel")
	local icon_noreturnbox = point_of_no_return_panel:child("icon_noreturnbox")
	local point_of_no_return_text = point_of_no_return_panel:child("noreturn_text")
	local point_of_no_return_timer = point_of_no_return_panel:child("noreturn_time")
	local noreturn_data = self:_get_noreturn_data(id)

	if noreturn_data.color ~= self._noreturn_data.color then
		point_of_no_return_text:set_color(noreturn_data.color)
		point_of_no_return_timer:set_color(noreturn_data.color)
		icon_noreturnbox:set_color(noreturn_data.color)
	end

	local x = self._noreturn_data.texture_rect or {}
	local y = noreturn_data.texture_rect or {}
	local texture_rects_match = x[1] == y[1] and x[2] == y[2] and x[3] == y[3] and x[4] == y[4]

	if noreturn_data.texture ~= self._noreturn_data.texture or not texture_rects_match then
		icon_noreturnbox:set_image(noreturn_data.texture, unpack(noreturn_data.texture_rect))
	end

	if noreturn_data.text_id ~= self._noreturn_data.text_id then
		point_of_no_return_text:set_text(managers.localization:to_upper_text(noreturn_data.text_id))

		managers.hud:make_fine_text(point_of_no_return_text)
		point_of_no_return_text:set_right(point_of_no_return_panel:w() - point_of_no_return_timer:w() - self._text_offset - 10)
	end

	self._noreturn_data = noreturn_data
end

function HUDAssaultCorner:_popup_wave(text, color)
	local popup_panel = self._hud_panel:panel({
		w = 250,
		name = "wave_popup",
		h = tweak_data.hud_corner.assault_size + 10
	})

	popup_panel:set_center_x(self._hud_panel:w() / 2)
	popup_panel:set_center_y(self._hud_panel:h() / 3.5)

	local box = BoxGuiObject:new(popup_panel, {
		sides = {
			1,
			1,
			1,
			1
		}
	})

	box:set_color(color)
	popup_panel:rect({
		name = "bg",
		color = color:with_alpha(0.3)
	})
	popup_panel:text({
		name = "text",
		vertical = "center",
		align = "center",
		text = text,
		font = tweak_data.hud_corner.assault_font,
		font_size = tweak_data.hud_corner.assault_size,
		color = color
	})

	local function animate_popup(panel)
		local cx = panel:center_x()

		over(0.25, function (p)
			if alive(panel) then
				panel:set_w(p * 250)
				panel:set_center_x(cx)
				panel:child("text"):set_center_x(panel:w() / 2)
			end
		end)
		wait(2.5)
		over(0.25, function (p)
			if alive(panel) then
				panel:set_w((1 - p) * 250)
				panel:set_center_x(cx)
				panel:child("text"):set_center_x(panel:w() / 2)
			end
		end)

		if alive(panel) then
			panel:parent():remove(panel)
		end
	end

	popup_panel:animate(animate_popup)
end