local format_values = CSHUD:GetOption("format_values")
HUDCustodyTeammatePanels = class()
function HUDCustodyTeammatePanels:init(i, main_player)
    self._id = i

    self._main_player = main_player

    self._csgo = CSHUD:CreatePanel("csgo_hctp", 2, true)

    self._faction = CSHUD._cache.player_faction
    self._faction_texture = tweak_data.csgo.textures.faction.texture
    self._faction_texture_rect = tweak_data.csgo.textures.faction[self._faction].square

    self:AddPanel()

    self:AddListeners()
end

function HUDCustodyTeammatePanels:AddPanel()
    self._panel = self._csgo:panel({
        h = 51,
        y = 238 + (55 * (self._id - 1)) + CSHUD:ReturnResYDifferenceAbove1080(),
        x = CSHUD:ComputeEdgeX(self._csgo:w(), 0),
        visible = self._main_player
    })
    self._player_sign = self._csgo:bitmap({
        name = "player_sign",
        texture = "guis/textures/pd2_hud_cs/csgo/player_sign",
        layer = 25,
        x = self._panel:x() + 12,
        y = self._panel:y() - 2,
        visible = self._main_player
    })
    local panel = self._panel
    panel:bitmap({
        name = "selected",
        texture = "guis/textures/pd2_hud_cs/waiting_teammate_selected",
        layer = 1,
        x = 0,
        y = 0,
        visible = false
    })
    panel:bitmap({
        name = "bg",
        texture = "guis/textures/pd2_hud_cs/waiting_teammate_bg",
        layer = 2,
        x = 2,
        y = 2,
        w = 313,
        h = 46
    })
    panel:bitmap({
        name = "avatar",
        texture = self._faction_texture,
        texture_rect = self._faction_texture_rect,
        layer = 10,
        w = 46,
        h = 46,
        x = 2,
        y = 2,
        visible = not self._main_player
    })
    local hp = panel:rect({
        name = "hp",
        layer = 11,
        w = 267,
        h = 23,
        x = 48,
        y = 2,
        color = tweak_data.csgo.colors[self._faction]
    })
    local text = panel:text({
        text = format_values == 1 and "100" or "1000",
        name = "hp_text",
        align = "left",
        vertical = "center",
        font_size = 25,
        font = tweak_data.menu.pd2_large_font,
        blend_mode = "normal",
        layer = 12,
        color = Color.white
    })
    managers.hud:make_fine_text(text)
    text:set_center(hp:center())
    text:set_x(68)
    if self._main_player then
        self:SetHPBar({ current = 0, total = 1 })
    end
    local name = panel:text({
        text = "NAME",
        name = "name",
        align = "left",
        vertical = "center",
        font_size = 25,
        font = tweak_data.menu.pd2_large_font,
        blend_mode = "normal",
        layer = 12,
        color = Color.white
    })
    managers.hud:make_fine_text(name)
    name:set_center(hp:center())
    name:set_x(format_values == 1 and 102 or 100)
    panel:rect({
        name = "avatar_bg",
        layer = 9,
        w = 46,
        h = 46,
        x = 2,
        y = 2,
        color = Color.black,
        visible = self._main_player
    })
    panel:bitmap({
        name = "primary",
        layer = 15,
        h = 32,
        w = 64,
        x = 322,
        y = 7,
        visible = not self._main_player
    })
    panel:bitmap({
        name = "secondary",
        layer = 15,
        h = 32,
        w = 64,
        x = 257,
        y = 4,
        visible = not self._main_player
    })
    local t, texture_rect = nil, nil
    if self._main_player then
        t, texture_rect = tweak_data.hud_icons:get_icon_data("mugshot_in_custody")
    end
    panel:bitmap({
        name = "condition_icon",
        layer = 15,
        w = 46,
        h = 46,
        x = 2,
        y = 2,
        texture = t,
        texture_rect = texture_rect,
        visible = self._main_player
    })
    panel:text({
		vertical = "center",
		name = "condition_timer",
		align = "center",
		text = "000",
		visible = false,
		layer = 20,
		color = Color.white,
		font_size = tweak_data.hud_players.timer_size,
		font = tweak_data.hud_players.timer_font
    })
    panel:child("condition_timer"):set_center(panel:child("condition_icon"):center())
end

function HUDCustodyTeammatePanels:AddListeners()
    CSHUD:AddListener(CSHUD.ListenerEvent.UpdateAvatar, callback(self, self, "UpdateAvatarTexture"))
    CSHUD:AddListener(CSHUD.ListenerEvent.SetAI, callback(self, self, "SetAI"))
    --CSHUD:AddListener(CSHUD.ListenerEvent.RemovePanel, callback(self, self, "RemovePanel"))
end

function HUDCustodyTeammatePanels:UpdateAvatarTexture(texture, texture_rect)
    if texture_rect then
        self._panel:child("avatar"):set_image(texture, unpack(texture_rect))
    else
        self._panel:child("avatar"):set_image(texture)
    end
end

local function sign(v)
	return (v >= 0 and 1) or -1
end

local function round(v, bracket)
    bracket = bracket or 1
	return math.floor(v / bracket + sign(v) * 0.5) * bracket
end

if format_values == 1 then
    function HUDCustodyTeammatePanels:SetHPBar(data)
        local panel = self._panel
        local bar = panel:child("hp")
        local text = panel:child("hp_text")
        local health = data.current / data.total
        bar:set_w(267 * health)
        text:set_text(round(health, 0.01) * 100)
    end
else
    function HUDCustodyTeammatePanels:SetHPBar(data)
        local panel = self._panel
        local bar = panel:child("hp")
        local text = panel:child("hp_text")
        bar:set_w(267 * (data.current / data.total))
        text:set_text(round(data.current, 0.1) * 10)
    end
end

function HUDCustodyTeammatePanels:SetName(name)
    local panel = self._panel:child("name")
    panel:set_text(name)
    local h = panel:h()
    managers.hud:make_fine_text(panel)
    panel:set_h(h)
end

function HUDCustodyTeammatePanels:SetAI(ai)
    self._ai = ai
    self._panel:child("avatar_bg"):set_visible(ai and true or false)
end

--[[
    This function is only called for your teammates and AI
]]
function HUDCustodyTeammatePanels:SetWeapons(peer_id, ai, ai_loadout_params)
    local primary_texture
    local secondary_texture = ""
    local secondary_hide = ai
    if peer_id then -- Teammate
        local peer = managers.network:session():peer(peer_id)
        local outfit = peer:blackmarket_outfit()
        primary_texture = CSHUD:GetWeaponTexture(outfit.primary.factory_id).texture
        secondary_texture = CSHUD:GetWeaponTexture(outfit.secondary.factory_id).texture
    else -- AI
        local outfit = ai_loadout_params.loadout and ai_loadout_params.loadout.primary or managers.blackmarket:henchman_loadout(self._id).primary
        if not outfit then -- AI uses default weapon
            outfit = tweak_data.character[ai_loadout_params.character].weapon.weapons_of_choice.primary
        end
        local primary = outfit:gsub("_npc", "") -- gsub also returns number as a second result
        primary_texture = CSHUD:GetWeaponTexture(primary).texture
    end
    local panel = self._panel
    local primary = panel:child("primary")
    local secondary = panel:child("secondary")
    primary:set_image(primary_texture)
    primary:set_texture_rect(primary:texture_width(), 0, -primary:texture_width(), primary:texture_height())
    secondary:set_image(secondary_texture)
    secondary:set_texture_rect(secondary:texture_width(), 0, -secondary:texture_width(), secondary:texture_height())
    local hp = panel:child("hp")
    secondary:set_center(hp:center())
    secondary:set_y(secondary:y() + hp:h())
    secondary:set_x(313 - secondary:w())
    secondary:set_visible(not secondary_hide)
end

function HUDCustodyTeammatePanels:SetTeammateWeaponSelected(w_id)
    local is_secondary = w_id == 1
    local panel = self._panel
    panel:child("primary"):set_alpha(is_secondary and 0.25 or 1)
    panel:child("secondary"):set_alpha(is_secondary and 1 or 0.25)
end

function HUDCustodyTeammatePanels:SetVisible(visible)
    self._csgo:set_visible(visible)
end

function HUDCustodyTeammatePanels:SetPanelVisible(visible)
    local panel = self._panel
    panel:set_visible(visible)
    self._csgo:child("player_sign"):set_visible(visible)
    if not visible then
        panel:child("avatar"):set_image(self._faction_texture)
        panel:child("secondary"):set_visible(true)
        self:SetAI(false)
        self:StopTimer()
    end
end

function HUDCustodyTeammatePanels:SetWatching(i)
    self._panel:child("selected"):set_visible(self._id == i)
end

function HUDCustodyTeammatePanels:SetCondition(icon_data)
    if self._main_player then
        return
    end
    local panel = self._panel
    local condition_icon = panel:child("condition_icon")
    local avatar = panel:child("avatar")
    local bg = panel:child("avatar_bg")
	if icon_data == "mugshot_normal" then
        condition_icon:set_visible(false)
        avatar:set_visible(true)
        if not self._ai then
            bg:set_visible(false)
        end
    else
        avatar:set_visible(false)
        condition_icon:set_visible(true)
        bg:set_visible(true)

		local icon, texture_rect = tweak_data.hud_icons:get_icon_data(icon_data)

        condition_icon:set_image(icon, texture_rect[1], texture_rect[2], texture_rect[3], texture_rect[4])
    end
end

function HUDCustodyTeammatePanels:StartTimer(time)
    self._timer_paused = false
    self._timer = time

    local timer = self._panel:child("condition_timer")

	timer:set_font_size(tweak_data.hud_players.timer_size)
	timer:set_color(Color.white)
	timer:stop()
	timer:set_visible(true)
	timer:animate(callback(self, self, "_animate_timer"))
end

function HUDCustodyTeammatePanels:SetPauseTimer(pause)
    self._timer_paused = pause
end

function HUDCustodyTeammatePanels:StopTimer()
    self._panel:child("condition_timer"):set_visible(false)
	self._panel:child("condition_timer"):stop()
end

function HUDCustodyTeammatePanels:_animate_timer(o)
    local rounded_timer = math.round(self._timer)

	while self._timer >= 0 do
		local dt = coroutine.yield()

		if not self._timer_paused then
			self._timer = self._timer - dt
			local text = self._timer < 0 and "00" or (math.round(self._timer) < 10 and "0" or "") .. math.round(self._timer)

			o:set_text(text)

			if math.round(self._timer) < rounded_timer then
				rounded_timer = math.round(self._timer)

				if rounded_timer < 11 then
					o:animate(callback(self, self, "_animate_timer_flash"))
				end
			end
		end
	end
end

function HUDCustodyTeammatePanels:_animate_timer_flash(o)
	local t = 0

	while t < 0.5 do
		t = t + coroutine.yield()
		local n = 1 - math.sin(t * 180)
		local r = math.lerp(1, 1, n)
		local g = math.lerp(0, 0.8, n)
		local b = math.lerp(0, 0.2, n)

		o:set_color(Color(r, g, b))
		o:set_font_size(math.lerp(tweak_data.hud_players.timer_size, tweak_data.hud_players.timer_flash_size, n))
	end

	o:set_font_size(30)
end

function HUDCustodyTeammatePanels:SetCustody(in_custody)
    if self._main_player then
        return
    end
    local panel = self._panel
    panel:child("primary"):set_visible(not in_custody)
    if not self._ai then
        panel:child("secondary"):set_visible(not in_custody)
    end
end

function HUDCustodyTeammatePanels:SetCallsign(id)
    local alpha = self._csgo:child("player_sign"):color().a
    self._csgo:child("player_sign"):set_color((tweak_data.chat_colors[id] or tweak_data.chat_colors[#tweak_data.chat_colors]):with_alpha(alpha))
end