if CSHUD:IsVROrComponentIsDisabled("interaction") then
	return
end

function HUDInteraction:show_interaction_bar(current, total, tweak_data_id)
	if self._interact_circle then
		self._interact_circle:remove()

        self._interact_circle = nil
	end

	self._interact_circle = CircleBitmapGuiObject:new(self._hud_panel, {
        image = "guis/textures/pd2_hud_cs/interaction_texture",
		use_bg = true,
		blend_mode = "add",
		layer = 2,
		radius = self._circle_radius,
		sides = self._sides,
		current = self._sides,
		total = self._sides,
		color = Color.white:with_alpha(1)
    })

    self._interact_circle:set_position(self._hud_panel:w() / 2 - self._circle_radius, self._hud_panel:h() / 2 - self._circle_radius)
end

function HUDInteraction:hide_interaction_bar(complete)
	if complete then
		local bitmap = self._hud_panel:bitmap({
			texture = "guis/textures/pd2_hud_cs/interaction_texture",
			blend_mode = "add",
			layer = 2,
			align = "center",
			valign = "center"
		})

		bitmap:set_position(bitmap:parent():w() / 2 - bitmap:w() / 2, bitmap:parent():h() / 2 - bitmap:h() / 2)

		local radius = 64
		local circle = CircleBitmapGuiObject:new(self._hud_panel, {
            image = "guis/textures/pd2_hud_cs/interaction_texture",
			sides = 64,
			current = 64,
			total = 64,
			blend_mode = "normal",
			layer = 3,
			radius = radius,
			color = Color.white:with_alpha(1)
		})

		circle:set_position(self._hud_panel:w() / 2 - radius, self._hud_panel:h() / 2 - radius)
		bitmap:animate(callback(self, self, "_animate_interaction_complete"), circle)
	end

	if self._interact_circle then
		self._interact_circle:remove()

        self._interact_circle = nil
	end
end

function HUDInteraction:set_bar_valid(valid, text_id)
	local texture = valid and "guis/textures/pd2_hud_cs/interaction_texture" or "guis/textures/pd2/hud_progress_invalid"

	self._interact_circle:set_image(texture)
	self._hud_panel:child(self._child_name_text):set_visible(valid)

	local invalid_text = self._hud_panel:child(self._child_ivalid_name_text)

	if text_id then
		invalid_text:set_text(managers.localization:to_upper_text(text_id))
	end

	invalid_text:set_visible(not valid)
end