local CSHUD = CSHUD
HUDKillFeed = class()
HUDKillFeed._units =
{
    tank = "Bulldozer",
    tank_green = "Green Bulldozer",
    tank_black = "Black Bulldozer",
    tank_hw = "Headless dozer",
    tank_skull = "Skulldozer",
    tank_mini = "Minigundozer",
    tank_medic = "Medicdozer",
    shield = "Shield",
    spooc = "Cloaker",
    medic = "Medic",
    taser = "Taser",
    sniper = "Sniper",
    phalanx_minion = "Winter's Minion",
    marshal_marksman = "Marshal Sniper",
    marshal_shield = "Marshal Shield",
    marshal_shield_break = "Marshal",

    civilian = "Civilian",
    old_hoxton_mission = "Hoxton",

    cop = "Cop",
    city_swat = "Light Unit",
    fbi_swat = "Light Unit",
    swat = "Light Unit",
    fbi_heavy_swat = "Heavy Unit",
    heavy_swat = "Heavy Unit",
    fbi = "FBI Officer",
    security = "Security Guard",

    snowman_boss = "Snowman",
    piggydozer = "Warthog"
}
-- The game holds which weapons have different name here
HUDKillFeed._weapon_override = deep_clone(tweak_data.animation.animation_redirects or {})
HUDKillFeed._weapon_override.ak47_ass = "ak74"
HUDKillFeed._weapon_override.mac11 = "mac10"
HUDKillFeed._weapon_override.ump = "schakal"
if Global.game_settings.difficulty == "sm_wish" and tweak_data.levels:get_ai_group_type() == "america" then
    HUDKillFeed._units.tank = "Zealdozer"
    HUDKillFeed._units.tank_green = "Green Zealdozer"
    HUDKillFeed._units.tank_black = "Black Zealdozer"
end
local cache = {}
local headshot_cache = {}
local weapon_cache = {}
function HUDKillFeed:init(hud)
    self._hud_panel = hud.panel
    self._queue = {}
    self._tweak_table = tweak_data.csgo.killfeed
    self._player_color = self._tweak_table[CSHUD._cache.player_faction]
    self._enemy_color = self._tweak_table[CSHUD._cache.enemy_faction]
    self._n = 0
    self._scale = 1
    self._players_slotmask = managers.slot:get_mask("players")
    self._local_player_slotmask = managers.slot:get_mask("players_only_local")
    managers.criminals:add_listener("CSHUD_Killfeed_add_criminal_event", {"on_criminal_added"}, callback(self, self, "OnCriminalAdded"))
    managers.criminals:add_listener("CSHUD_Killfeed_remove_criminal_event", {"on_criminal_removed"}, callback(self, self, "OnCriminalRemoved"))

    --self:AddFeed(Idstring("UnitTest"), "tank", "tank_green", { variant = "graze", headshot = true } )
end

-- The positioning stuff here is purely a nightmare and hackland
function HUDKillFeed:AddFeed(unit, unit_name, unit_stats_name, damage_info)
    local victim_key = tostring(unit:key())
    if self._hud_panel:child(victim_key) then
        return
    end
    local attacker_name = "<Unknown>"
    local victim_name = self._units[unit_name] or unit_name
    --local victim_name = unit_stats_name and self._units[unit_stats_name] or self._units[unit_name] or unit_name
    local time_multiplier = 1
    local local_player = false
    local attacker_color = self._player_color
    local enemy_color = self._enemy_color
    if unit_name == "civilian" then
        enemy_color = Color.white
    end
    local attacker = damage_info.attacker_unit
    local attacker_key = nil
    local attacker_is_valid = false
    local attacker_weapon = nil
    local headshot = false
    if attacker and alive(attacker) then
        attacker_is_valid = true
        attacker_key = tostring(attacker:key())
        if attacker:in_slot(self._players_slotmask) then -- Player or teammate
            if attacker:in_slot(self._local_player_slotmask) then -- Player
                local_player = true
                attacker_weapon = damage_info.weapon_unit
                headshot = damage_info.headshot
                time_multiplier = self._tweak_table.local_player
            else
                attacker_weapon = attacker:inventory() and attacker:inventory():equipped_unit()
                headshot = self:UncacheHeadshot(victim_key)
                time_multiplier = self._tweak_table.other_player
            end
            if cache[attacker_key] then
                attacker_name = cache[attacker_key].name
            else
                local peer = managers.network:session():peer_by_unit(attacker)
                local peer_name = peer:name()
                attacker_name = peer_name
                cache[attacker_key] = { name = peer_name, id = peer:id(), character = peer:character(), melee_id = peer:melee_id() }
            end
        elseif attacker:in_slot(12) then -- Enemy or ally
            local team_data = attacker:movement() and attacker:movement().team and attacker:movement():team()
            if team_data then
                if team_data.id == "criminal1" then
                    attacker_name = "<Ally>"
                else
                    attacker_name = "<Enemy>"
                    attacker_color = Color.white
                end
            else -- Assume enemy
                attacker_name = "<Enemy>"
                attacker_color = Color.white
            end
            headshot = damage_info.headshot or self:UncacheHeadshot(victim_key)
            attacker_weapon = damage_info.weapon_unit
        elseif attacker:in_slot(16) then -- Joker/Bot
            headshot = damage_info.headshot or self:UncacheHeadshot(victim_key)
            attacker_weapon = damage_info.weapon_unit or attacker:inventory() and attacker:inventory():equipped_unit()
            if cache[attacker_key] then
                attacker_name = cache[attacker_key].name
            else
                local name = ""
                if attacker:base().nick_name then -- Bot
                    name = attacker:base():nick_name()
                else -- Assume it is a Joker
                    name = "<Joker>"
                    if attacker:brain() and attacker:brain().convert_to_criminal then
                        unit:base():add_destroy_listener("CSHUD_Killfeed", callback(self, self, "OnJokerKilled", true))
                        unit:character_damage():add_listener("CSHUD_Killfeed", {"death"}, callback(self, self, "OnJokerKilled", true))
                    end
                end
                cache[attacker_key] = { name = name }
                attacker_name = name
            end
        elseif attacker:in_slot(25) then -- Turret
            headshot = damage_info.headshot or self:UncacheHeadshot(victim_key)
            attacker_name = "<Sentry>"
        elseif attacker:base().thrower_unit then
            attacker_name = "<Grenade>"
        end
    else
        --CSHUD:Log("attacker is nil or not alive, for some reason")
        --self:LogAndRemovePanel(nil, damage_info)
        attacker_name = ""
    end
    local panel = self._hud_panel:panel({
        name = victim_key,
        x = 100,
        y = 100,
        h = 32,
        alpha = 0
    })
    local attacker_text = panel:text({
        name = "attacker",
        align = "center",
        vertical = "center",
        text = attacker_name,
        color = attacker_color,
        blend_mode = "normal",
        font = tweak_data.menu.pd2_large_font,
        font_size = 18,
        x = 10,
        y = 7
    })
    managers.hud:make_fine_text(attacker_text)
    local attack_type
    if damage_info.variant == "graze" then
        local graze = panel:bitmap({
            name = "graze",
            texture = "guis/textures/pd2/skilltree_2/icons_atlas_2",
            texture_rect = {880, 720, 80, 80},
            w = 24,
            h = 24,
            y = attacker_text:y() - 4
        })
        graze:set_left(attacker_text:right())
        attack_type = graze
    elseif damage_info.variant == "explosion" then
        local e = panel:bitmap({
            name = "explosion",
            texture = self._tweak_table.texture,
            texture_rect = self._tweak_table.explosion,
            w = 24,
            h = 24,
            y = attacker_text:y() - 4
        })
        e:set_left(attacker_text:right())
        attack_type = e
    elseif damage_info.variant == "fire" then
        local fire = panel:bitmap({
            name = "fire",
            texture = self._tweak_table.texture,
            texture_rect = self._tweak_table.fire,
            w = 37.25,
            h = 24,
            y = attacker_text:y() - 4
        })
        fire:set_left(attacker_text:right())
        attack_type = fire
    elseif damage_info.variant == "poison" then
        local poison = panel:bitmap({
            name = "poison",
            texture = self._tweak_table.texture,
            texture_rect = self._tweak_table.suicide,
            w = 24,
            h = 24,
            y = attacker_text:y() - 4
        })
        poison:set_left(attacker_text:right())
        attack_type = poison
    elseif damage_info.variant == "melee" then
        local melee_id = damage_info.name_id or "fists"
        if damage_info.is_synced and attacker_is_valid and cache[attacker_key] then
            melee_id = cache[attacker_key].melee_id
        end
        local m_texture = CSHUD:GetMeleeTexture(melee_id)
        local melee = panel:bitmap({
            name = "melee",
            texture = m_texture.texture,
            w = 48,
            h = 24,
            y = attacker_text:y() - 4
        })
        if m_texture.inverted then
            melee:set_texture_rect(melee:texture_width(), 0, -melee:texture_width(), melee:texture_height())
        end
        melee:set_left(attacker_text:right())
        attack_type = melee
    elseif damage_info.variant == "custody" then -- Custom variant
        victim_name = damage_info.name
        local custody = panel:bitmap({
            name = "custody",
            texture = "guis/textures/hud_icons",
		    texture_rect = {192, 464, 48, 48},
            w = 24,
            h = 24,
            y = attacker_text:y() - 4
        })
        custody:set_left(attacker_text:right())
        attack_type = custody
        attacker_text:set_text("")
        enemy_color = self._player_color
        local_player = damage_info.local_player
    elseif damage_info.variant == "convert" then -- Custom variant
        local convert = panel:bitmap({
            name = "convert",
            texture = "guis/textures/pd2/skilltree/icons_atlas",
            texture_rect = {384, 512, 64, 64},
            w = 24,
            h = 24,
            y = attacker_text:y() - 4
        })
        convert:set_left(attacker_text:right())
        attack_type = convert
    elseif attacker_weapon and alive(attacker_weapon) then
        local weapon_key = tostring(attacker_weapon:key())
        if not weapon_cache[weapon_key] then
            local weapon_id, _ = attacker_weapon:base():get_name_id():gsub("_npc", ""):gsub("_crew", "")
            local fixed_w_id = self._weapon_override[weapon_id] or weapon_id
            if not tweak_data.weapon[fixed_w_id] then
                CSHUD:Log("Weapon ID in tweak_data is nil; Weapon ID: " .. tostring(fixed_w_id))
                self:LogAndRemovePanel(panel, nil)
                return
            end
            weapon_cache[weapon_key] = CSHUD:GetWeaponTextureByWeaponID(fixed_w_id).texture
        end
        local weapon = panel:bitmap({
            name = "weapon",
            texture = weapon_cache[weapon_key],
            w = 48,
            h = 24,
            y = attacker_text:y() - 4
        })
        weapon:set_texture_rect(weapon:texture_width(), 0, -weapon:texture_width(), weapon:texture_height())
        weapon:set_left(attacker_text:right())
        attack_type = weapon
    else
        local unknown = panel:bitmap({
            name = "unknown",
            texture = self._tweak_table.texture,
            texture_rect = self._tweak_table.suicide,
            w = 24,
            h = 24,
            y = attacker_text:y() - 4
        })
        unknown:set_left(attacker_text:right())
        attack_type = unknown
    end
    if headshot then
        local hs = panel:bitmap({
            name = "headshot",
            texture = self._tweak_table.texture,
            texture_rect = self._tweak_table.headshot,
            w = 16,
            h = 16,
            y = attacker_text:y()
        })
        hs:set_left(attack_type:right())
    end
    local victim_text = panel:text({
        name = "victim",
        align = "center",
        vertical = "center",
        text = victim_name,
        color = enemy_color,
        blend_mode = "normal",
        font = tweak_data.menu.pd2_large_font,
        font_size = 18,
        y = attacker_text:y()
    })
    managers.hud:make_fine_text(victim_text)
    victim_text:set_left(headshot and panel:child("headshot"):right() + 2 or attack_type:right() + 2)
    panel:set_w(victim_text:right() + 10)
    panel:set_right(self._hud_panel:w())
    panel:rect({
        name = "bg",
        layer = -2,
        color = Color(0.25, 0, 0, 0)
    })
    if local_player then
        panel:rect({
            name = "top",
            color = Color.red,
            layer = -1,
            x = 0,
            y = 0,
            h = 2,
            w = panel:w()
        })
        panel:rect({
            name = "right",
            color = Color.red,
            layer = -1,
            x = panel:w() - 2,
            y = 2,
            w = 2,
            h = panel:h() - 2
        })
        panel:rect({
            name = "bottom",
            color = Color.red,
            layer = -1,
            x = 0,
            y = panel:h() - 2,
            h = 2,
            w = panel:w()
        })
        panel:rect({
            name = "left",
            color = Color.red,
            layer = -1,
            x = 0,
            y = 2,
            w = 2,
            h = panel:h() - 2
        })
    end
    while self._queue[panel:y()] do
        panel:set_y(panel:y() + 40)
    end
    self._queue[panel:y()] = true
    local function anim(o)
        over(0.25, function(p)
            o:set_alpha(math.lerp(0, 1, p))
        end)
        wait(self._tweak_table.onscreen * time_multiplier)
        self._queue[o:y()] = nil
        over(0.25, function(p)
            o:set_alpha(math.lerp(1, 0, p))
        end)
        o:parent():remove(o)
    end
    panel:animate(anim)
end

function HUDKillFeed:OnCriminalAdded(name, unit, peer_id, ai)
    for key, player in pairs(cache) do
        if player.character == name then
            cache[key] = nil
        end
    end
end

function HUDKillFeed:OnCriminalRemoved(char_data)
    self:OnCriminalAdded(char_data.name)
end

function HUDKillFeed:OnJokerKilled(void, minion_unit, damage_info)
    local key = tostring(minion_unit:key())
    if not cache[key] then
        return
    end
    cache[key] = nil
    local weapon_key = minion_unit:inventory() and minion_unit:inventory():equipped_unit() and tostring(minion_unit:inventory():equipped_unit():key())
    if not weapon_cache[weapon_key] then
        return
    end
    weapon_cache[weapon_key] = nil
end

function HUDKillFeed:LogAndRemovePanel(panel, damage_info)
    for key, value in pairs(damage_info or {}) do
        CSHUD:Log("[" .. tostring(key) .. "]: " .. tostring(value))
    end
    if panel then
        self._hud_panel:remove(panel)
    end
end

function HUDKillFeed:CacheHeadshot(unit_key)
    headshot_cache[unit_key] = true
end

function HUDKillFeed:UncacheHeadshot(unit_key)
    local value = headshot_cache[unit_key]
    headshot_cache[unit_key] = nil
    return value
end

function HUDKillFeed:update(t, dt)
end

if _G.IS_VR then
    dofile(CSHUD.LuaPath .. "lib/managers/hud/vr/HUDKillfeedVR.lua")
end