local original =
{
    _create_downed_hud = HUDManager._create_downed_hud,
    _create_custody_hud = HUDManager._create_custody_hud,
    set_teammate_grenades = HUDManager.set_teammate_grenades,
    animate_grenade_flash = HUDManager.animate_grenade_flash,
    set_teammate_grenades_amount = HUDManager.set_teammate_grenades_amount,
    set_cable_ties_amount = HUDManager.set_cable_ties_amount,
    set_teammate_name = HUDManager.set_teammate_name,
    set_teammate_callsign = HUDManager.set_teammate_callsign,
    temp_show_carry_bag = HUDManager.temp_show_carry_bag,
    temp_hide_carry_bag = HUDManager.temp_hide_carry_bag,
    sync_set_assault_mode = HUDManager.sync_set_assault_mode,
    add_teammate_panel = HUDManager.add_teammate_panel
}

function HUDManager:_create_downed_hud(hud)
    original._create_downed_hud(self, hud)
    local downed = self._hud_player_downed
    downed._hud.timer:set_y(downed._hud.timer:y() + 10)
    downed._hud_panel:child("downed_panel"):child("timer_msg"):set_y(downed._hud_panel:child("downed_panel"):child("timer_msg"):y() + 10)
end

function HUDManager:_create_custody_hud(hud)
    original._create_custody_hud(self, hud)
    local custody = self._hud_player_custody
    custody._timer:set_y(custody._timer:y() + 10)
    custody._hud_panel:child("custody_panel"):child("timer_msg"):set_y(custody._hud_panel:child("custody_panel"):child("timer_msg"):y() + 10)
end

function HUDManager:set_teammate_health(i, data)
    self._teammate_panels[i]:SetTeammateHPBar(data)
    self._custody_teammate_panels[i]:SetHPBar(data)
    self._stats_screen_new:SetHP(i, data)
end

function HUDManager:_set_weapon_selected(id)
    self._hud.selected_weapon = id

    self._teammate_panels[HUDManager.PLAYER_PANEL]:set_weapon_selected(id)
end

function HUDManager:_set_teammate_weapon_selected(i, id, icon)
    self._custody_teammate_panels[i]:SetTeammateWeaponSelected(id)
end

function HUDManager:GetMainPanel()
    return self._teammate_panels[HUDManager.PLAYER_PANEL]._csgo
end

function HUDManager:set_ammo_amount(selection_index, max_clip, current_clip, current_left, max)
    if selection_index > 3 then
        print("set_ammo_amount", selection_index, max_clip, current_clip, current_left, max)
        Application:stack_dump()
        debug_pause("WRONG SELECTION INDEX!")
    end

    managers.player:update_synced_ammo_info_to_peers(selection_index, max_clip, current_clip, current_left, max)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:set_ammo_amount_by_type(selection_index == 1 and "secondary" or "primary", max_clip, current_clip, current_left, max)
end

function HUDManager:set_teammate_ammo_amount(id, selection_index, max_clip, current_clip, current_left, max)
end

function HUDManager:set_player_health(data)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:set_health(data)
    self._stats_screen_new:SetHP(HUDManager.PLAYER_PANEL, data)
end

function HUDManager:set_teammate_armor(i, data)
    self._stats_screen_new:SetAP(i, data)
end

function HUDManager:set_item_amount(index, amount)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:set_deployable_equipment_amount(index, { amount = amount })
end

function HUDManager:set_teammate_deployable_equipment_amount(i, index, data)
end

function HUDManager:set_teammate_grenades(i, data)
    if i == HUDManager.PLAYER_PANEL then
        original.set_teammate_grenades(self, i, data)
    else
        self:set_ability_icon(i, data.icon)
    end
end

function HUDManager:animate_grenade_flash(i)
    if i == HUDManager.PLAYER_PANEL then
        original.animate_grenade_flash(self, i)
    end
end

function HUDManager:set_teammate_grenades_amount(i, data)
    if i == HUDManager.PLAYER_PANEL then
        original.set_teammate_grenades_amount(self, i, data)
    end
end

local _f_set_cable_tie = HUDManager.set_cable_tie
function HUDManager:set_cable_tie(i, data)
    if i == HUDManager.PLAYER_PANEL then
        _f_set_cable_tie(self, i, data)
    end
end

function HUDManager:set_cable_ties_amount(i, amount)
    if i == HUDManager.PLAYER_PANEL then
        original.set_cable_ties_amount(self, i, amount)
    end
end

function HUDManager:add_special_equipment(data)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:add_special_equipment(data)
    self._stats_screen_new:AddSpecialEquipment(HUDManager.PLAYER_PANEL, data)
end

function HUDManager:add_teammate_special_equipment(i, data)
    self._stats_screen_new:AddSpecialEquipment(i, data)
end

function HUDManager:remove_teammate_special_equipment(panel_id, equipment)
    self._stats_screen_new:RemoveSpecialEquipment(panel_id, equipment)
end

function HUDManager:temp_show_carry_bag(carry_id, value)
    original.temp_show_carry_bag(self, carry_id, value)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:set_carry_info()
end

function HUDManager:temp_hide_carry_bag()
    original.temp_hide_carry_bag(self)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:remove_carry_info()
end

function HUDManager:set_teammate_special_equipment_amount(i, equipment_id, amount)
end

function HUDManager:set_ai_stopped(ai_id, stopped)
    self._teammate_panels[ai_id]:set_ai_stopped(stopped)
end

function HUDManager:set_teammate_callsign(i, id)
    original.set_teammate_callsign(self, i, id)
    self._stats_screen_new:SetCallsign(i, id)
end

if not Global.game_settings.single_player then -- Optimization, useless to compute in Single Player
    local update = HUDManager.update
    local last_ping_update = 0
    function HUDManager:update(t, dt)
        update(self, t, dt)
        if last_ping_update + 5 < t then
            last_ping_update = t
            local peers = managers.network:session() and managers.network:session():peers()
            for _, peer in pairs(peers or {}) do
                if peer and peer:id() and peer:rpc() then
                    local panel = self._stats_screen_new:GetPanelByPeerID(peer:id())
                    if panel then
                        local qos = peer:qos()
                        self:SetStatsScreenPing(panel, math.ceil(qos.ping), qos.packet_loss)
                    end
                end
            end
        end
    end
end

if CSHUD:GetComponentOption("interaction") then
    local _f_align_teammate_name_label = HUDManager.align_teammate_name_label
    function HUDManager:align_teammate_name_label(panel, interact)
        interact:set_image("guis/textures/pd2_hud_cs/interaction_texture")
        _f_align_teammate_name_label(self, panel, interact)
    end

    function HUDManager:teammate_progress(peer_id, type_index, enabled, tweak_data_id, timer, success)
        local name_label = self:_name_label_by_peer_id(peer_id)

        if name_label then
            name_label.interact:set_visible(enabled)
            name_label.panel:child("action"):set_visible(enabled)

            local action_text = ""

            if type_index == 1 then
                action_text = managers.localization:text(tweak_data.interaction[tweak_data_id].action_text_id or "hud_action_generic")
            elseif type_index == 2 then
                if enabled then
                    local equipment_name = managers.localization:text(tweak_data.equipments[tweak_data_id].text_id)
                    local deploying_text = tweak_data.equipments[tweak_data_id].deploying_text_id and managers.localization:text(tweak_data.equipments[tweak_data_id].deploying_text_id) or false
                    action_text = deploying_text or managers.localization:text("hud_deploying_equipment", {
                        EQUIPMENT = equipment_name
                    })
                end
            elseif type_index == 3 then
                action_text = managers.localization:text("hud_starting_heist")
            end

            name_label.panel:child("action"):set_text(utf8.to_upper(action_text))
            name_label.panel:stop()

            if enabled then
                name_label.panel:animate(callback(self, self, "_animate_label_interact"), name_label.interact, timer)
            elseif success then
                local panel = name_label.panel
                local bitmap = panel:bitmap({
                    blend_mode = "add",
                    texture = "guis/textures/pd2_hud_cs/interaction_texture",
                    layer = 2,
                    align = "center",
                    rotation = 360,
                    valign = "center"
                })

                bitmap:set_size(name_label.interact:size())
                bitmap:set_position(name_label.interact:position())

                local radius = name_label.interact:radius()
                local circle = CircleBitmapGuiObject:new(panel, {
                    blend_mode = "normal",
                    rotation = 360,
                    layer = 3,
                    radius = radius,
                    color = Color.white:with_alpha(1),
                    image = "guis/textures/pd2_hud_cs/interaction_texture"
                })

                circle:set_position(name_label.interact:position())
                bitmap:animate(callback(HUDInteraction, HUDInteraction, "_animate_interaction_complete"), circle)
            end
        end

        local character_data = managers.criminals:character_data_by_peer_id(peer_id)

        if character_data then
            self._teammate_panels[character_data.panel_id]:teammate_progress(enabled, tweak_data_id, timer, success)
        end
    end
end

function HUDManager:hide_player_gear(panel_id)
    if self._teammate_panels[panel_id] and self._teammate_panels[panel_id]._csgo and self._teammate_panels[panel_id]._csgo:child("weapons") then
        local panel = self._teammate_panels[panel_id]._csgo
        local weapons_panel = panel:child("weapons")
        local ammo_counter_panel = panel:child("ammo")
        weapons_panel:set_visible(false)
        ammo_counter_panel:set_visible(false)
	end
end

function HUDManager:show_player_gear(panel_id)
    if self._teammate_panels[panel_id] and self._teammate_panels[panel_id]._csgo and self._teammate_panels[panel_id]._csgo:child("weapons") then
        local panel = self._teammate_panels[panel_id]._csgo
        local weapons_panel = panel:child("weapons")
        local ammo_counter_panel = panel:child("ammo")
        weapons_panel:set_visible(true)
        ammo_counter_panel:set_visible(true)
	end
end

function HUDManager:ChangeManiacVisibility(visibility)
    self._teammate_panels[HUDManager.PLAYER_PANEL]:ShowManiac(visibility)
end