local function Center(o)
    o:set_x((o:parent():w() - o:w()) / 2)
end

HUDMessagePanel = class()
HUDMessagePanel._font_size = 22.5
function HUDMessagePanel:init(hud)
    self._hud_panel = hud.panel
    self._panel = self._hud_panel:panel({
        name = "HUDMessagePanel",
        w = 292.5,
        h = 78,
        visible = true,
        alpha = 0
    })
    self._panel:set_center_x(self._hud_panel:center_x())
    self._panel:set_y(self._hud_panel:h() - (self._panel:h()))
    self._panel:bitmap({
        name = "bg",
        layer = 1,
        texture = "guis/textures/pd2_hud_cs/panel_bg",
        alpha = 0.5,
        valign = "grow",
		halign = "grow",
        w = self._panel:w(),
        h = self._panel:h()
    })
    local warning = self._panel:text({
        name = "warning",
        text = "Alert",
        align = "center",
        vertical = "center",
        font_size = 30,
        font = tweak_data.menu.pd2_large_font,
        blend_mode = "normal",
        visible = true,
        layer = 2,
        color = Color.red
    })
    managers.hud:make_fine_text(warning)
    Center(warning)
    warning:set_y(2)
    local bomb_planted = self._panel:text({
        name = "bomb_planted",
        text = "Bomb has been planted.",
        align = "center",
        vertical = "center",
        font_size = self._font_size,
        font = tweak_data.menu.pd2_large_font,
        blend_mode = "normal",
        visible = true,
        layer = 3,
        color = Color.white
    })
    managers.hud:make_fine_text(bomb_planted)
    Center(bomb_planted)
    bomb_planted:set_top(warning:bottom())
    local time_remaining = self._panel:text({
        name = "time_remaining",
        text = "X to detonation.",
        align = "center",
        vertical = "center",
        font_size = self._font_size,
        font = tweak_data.menu.pd2_large_font,
        blend_mode = "normal",
        visible = true,
        layer = 3,
        color = Color.white
    })
    managers.hud:make_fine_text(time_remaining)
    Center(time_remaining)
    time_remaining:set_top(bomb_planted:bottom())
    time_remaining:set_x(bomb_planted:x())
    local warning_icon = self._panel:bitmap({
        name = "icon",
        texture = "guis/textures/pd2_hud_cs/warning",
        color = Color.red,
        w = 24,
        h = 24,
        y = 4,
        layer = 2
    })
    Center(warning_icon)
    warning_icon:set_right(warning:left() - 8)
    self._default_panel_y = self._panel:y()
end

function HUDMessagePanel:Test()
    CSHUD:DelayCall("BombMessageTest", 10, function()
        managers.hud:ShowBombMessage(150)
    end)
end

function HUDMessagePanel:ShowBombMessage(time)
    local panel = self._panel
    local time_remaining = panel:child("time_remaining")
    if time then
        time_remaining:set_visible(true)
        -- To center it properly
        time_remaining:set_text("X to detonation.")
        time_remaining:set_font_size(self._font_size)
        managers.hud:make_fine_text(time_remaining)
        Center(time_remaining)
        -- End of center hack
        time_remaining:set_text(string.format("%s to detonation.", CSHUD:FormatTime(time)))
        managers.hud:make_fine_text(time_remaining)
        if math.fmod(time, 60) > 0 then
            time_remaining:set_font_size(self._font_size - 4)
            Center(time_remaining)
        end
    else
        time_remaining:set_visible(false)
    end
    panel:stop()
    panel:animate(function(o)
        o:set_y(self._default_panel_y)
        o:set_alpha(0)
        over(0.25, function(p)
            o:set_alpha(math.lerp(0, 1, p))
            o:set_y(math.lerp(self._default_panel_y, self._default_panel_y - 175, p))
        end)
        wait(6)
        o:set_alpha(0)
    end)
end

if _G.IS_VR then
    dofile(CSHUD.LuaPath .. "lib/managers/hud/vr/HUDMessagePanelVR.lua")
end