if CSHUD:IsVROrComponentIsDisabled() then
	return
end

local _f_init = HUDPlayerCustody.init
function HUDPlayerCustody:init(hud)
    _f_init(self, hud)

    self._hud.trade_text1:hide() -- You are being traded
    self._hud.trade_text2:hide() -- Bain/Locke is negotiating
    self._hud_panel:child("custody_panel"):child("civilians_killed"):hide() -- Civilians killed
    self._hud_panel:child("custody_panel"):child("trade_delay"):hide() -- Trade Delay

    self._csgo = CSHUD:CreatePanel("csgo_custody")

    local panel_right = self._csgo:w() - 32

    self._csgo_custody_panel = self._csgo:panel({
        name = "custody_panel"
    })

    local civilians_killed = self._csgo_custody_panel:text({
        name = "civilians_killed",
        vertical = "top",
		h = 32,
		w = 400,
		align = "right",
		text = "Civilians killed",
		valign = "bottom",
		font = tweak_data.hud_custody.custody_font,
        font_size = tweak_data.hud_custody.small_font_size,
        visible = false
    })

    local trade_delay = self._csgo_custody_panel:text({
        name = "trade_delay",
        vertical = "top",
		h = 32,
		w = 400,
		align = "right",
		text = "Trade delay",
		valign = "bottom",
		font = tweak_data.hud_custody.custody_font,
        font_size = tweak_data.hud_custody.small_font_size,
        visible = false
    })

    local level_id = Global.level_data and Global.level_data.level_id
	local level_tweak = tweak_data.levels[level_id]
    local negotiator = self._csgo_custody_panel:text({
        name = "negotiator",
        vertical = "top",
		h = 32,
		w = 400,
		align = "right",
		text = utf8.to_upper(managers.localization:text("menu_spectator_being_traded_hesitant_" .. (level_tweak and level_tweak.narrator or "bain"))),
		valign = "bottom",
		font = tweak_data.hud_custody.custody_font,
        font_size = tweak_data.hud_custody.small_font_size,
        visible = false
    })

    local being_traded = self._csgo_custody_panel:text({
        name = "being_traded",
        vertical = "top",
		h = 32,
		w = 400,
		align = "right",
		text = utf8.to_upper(managers.localization:text("menu_spectator_being_traded")),
		valign = "bottom",
		font = tweak_data.hud_custody.custody_font,
        font_size = tweak_data.hud_custody.small_font_size,
        visible = false
    })

    local h = select(4, being_traded:text_rect())

    local equipment_top = tweak_data.csgo.position.equipment_top + CSHUD:ReturnResYDifferenceAbove1080()

    being_traded:set_h(h)
    being_traded:set_right(panel_right)
	being_traded:set_bottom(equipment_top)

    h = select(4, trade_delay:text_rect())

	trade_delay:set_h(h)
	trade_delay:set_right(panel_right)
    trade_delay:set_bottom(equipment_top)

    h = select(4, civilians_killed:text_rect())

	civilians_killed:set_h(h)
	civilians_killed:set_right(panel_right)
    civilians_killed:set_bottom(trade_delay:top())

    h = select(4, negotiator:text_rect())

	negotiator:set_h(h)
	negotiator:set_right(panel_right)
    negotiator:set_bottom(civilians_killed:top())
end

function HUDPlayerCustody:set_civilians_killed(amount)
	local amount_text = (amount < 10 and "0" or "") .. amount
	local civilians_killed = self._csgo_custody_panel:child("civilians_killed")

	civilians_killed:set_text(utf8.to_upper(managers.localization:text("hud_civilians_killed", {
		AMOUNT = tostring(amount_text)
	})))
end

function HUDPlayerCustody:set_trade_delay(time)
	if math.floor(time) == math.floor(self._last_trade_delay_time) then
		return
	end

	self._last_trade_delay_time = time
	local time_text = self:_get_time_text(time)
	local trade_delay = self._csgo_custody_panel:child("trade_delay")

	trade_delay:set_text(utf8.to_upper(managers.localization:text("hud_trade_delay", {
		TIME = tostring(time_text)
	})))
end

function HUDPlayerCustody:set_trade_delay_visible(visible)
	self._csgo_custody_panel:child("trade_delay"):set_visible(visible)
	self._csgo_custody_panel:child("civilians_killed"):set_visible(visible)
end

function HUDPlayerCustody:set_negotiating_visible(visible)
	self._csgo_custody_panel:child("negotiator"):set_visible(visible)
	self._csgo_custody_panel:child("negotiator"):stop()

	if visible then
		self._csgo_custody_panel:child("negotiator"):animate(callback(self, self, "_animate_text_pulse"))
	end
end

function HUDPlayerCustody:set_can_be_trade_visible(visible)
	self._csgo_custody_panel:child("being_traded"):stop()
	self._csgo_custody_panel:child("being_traded"):set_visible(visible)

	if visible then
		self._csgo_custody_panel:child("being_traded"):animate(callback(self, self, "_animate_text_pulse"))
	end
end