HUDScore = HUDScore or class()
function HUDScore:init(tweak_hud)
    local hud = managers.hud
    local player_team = CSHUD._cache.player_faction
    local enemy_team = CSHUD._cache.enemy_faction
    self._csgo = hud._teammate_panels[HUDManager.PLAYER_PANEL]._csgo -- messy
    local time = hud._hud_heist_timer._timer_text
    local time_bottom = time:y() + time:font_size()
    local left = self._csgo:child("avatar"):right()
    local right = managers.enemy.enemies:left()
    local middle = math.lerp(left, right, 0.5)
    self._panel = self._csgo:panel({
        name = "score_panel",
        visible = not tweak_hud.no_timer
    })
    local player_score = self._panel:text({
        text = "00",
        name = "player_score",
        align = "center",
        vertical = "center",
        font_size = 20,
        font = tweak_data.csgo.fonts.numbers.font,
        blend_mode = "normal",
        layer = 15,
        color = tweak_data.csgo.colors[player_team],
        w = 40,
        h = 40,
        visible = false
    })
    hud:make_fine_text(player_score)
    player_score:set_text("0")
    player_score:set_top(time_bottom)
    player_score:set_x(math.lerp(left, middle, 0.5) - (player_score:w() / 2))
    self._player_score = 0
    local enemy_score = self._panel:text({
        text = "00",
        name = "enemy_score",
        align = "center",
        vertical = "center",
        font_size = 20,
        font = tweak_data.csgo.fonts.numbers.font,
        blend_mode = "normal",
        layer = 15,
        color = tweak_data.csgo.colors[enemy_team],
        w = 40,
        h = 40,
        visible = false
    })
    hud:make_fine_text(enemy_score)
    enemy_score:set_text("0")
    enemy_score:set_top(time_bottom)
    enemy_score:set_x(math.lerp(middle, right, 0.5) - (enemy_score:w() / 2))
    self._enemy_score = 0
end

function HUDScore:SetPlayerScore(score)
    if score then
        self._player_score = score
    else
        self._player_score = self._player_score + 1
    end
    self._panel:child("player_score"):set_text(tostring(self._player_score))
end

function HUDScore:SetEnemyScore(score)
    self._enemy_score = score
    self._panel:child("enemy_score"):set_text(tostring(self._enemy_score))
end

if CSHUD:IsVROrComponentIsDisabled() then
    local function function_empty()
    end
    local score = HUDScore
    for k, _ in pairs(score) do
        score[k] = function_empty
    end
end