dofile(CSHUD.LuaPath .. "CSHUDMenu.lua")

Hooks:Add("LocalizationManagerPostInit", "LocalizationManagerPostInit_CSHUD", function(loc)
    local language_filename = nil
    if CSHUD.settings.mod_language == 1 then
        local LanguageKey =
        {
            ["PAYDAY 2 THAI LANGUAGE Mod"] = "thai",
            ["Ultimate Localization Manager & 正體中文化"] = "tchinese",
            ["PAYDAY 2 Translate in Portuguese Brazilian"] = "portuguese-br",
            ["Payday 2 Korean patch"] = "korean"
        }
        for _, mod in ipairs(BLT and BLT.Mods and BLT.Mods:Mods()) do
            language_filename = mod:IsEnabled() and LanguageKey[mod:GetName()] or nil
            if language_filename then
                break
            end
        end
        if not language_filename then
            for _, filename in ipairs(file.GetFiles(CSHUD.LocPath)) do
                local str = filename:match('^(.*).json$')
                if str and Idstring(str) and Idstring(str):key() == SystemInfo:language():key() then
                    language_filename = str
                    break
                end
            end
        end
        if language_filename then
            CSHUD.Language = language_filename
            loc:load_localization_file(CSHUD.LocPath .. language_filename .. ".json")
            loc:load_localization_file(CSHUD.LocPath .. "fun_facts/" .. language_filename .. ".json")
        end
    else
        local Languages =
        {
            [2] = "english",
            [3] = "french",
            [4] = "german",
            [5] = "italian",
            [6] = "russian",
            [7] = "thai",
            [8] = "schinese",
            [9] = "tchinese",
            [10] = "portuguese-br",
            [11] = "spanish",
            [12] = "korean"
        }
        CSHUD.Language = Languages[CSHUD.settings.mod_language]
        loc:load_localization_file(CSHUD.LocPath .. CSHUD.Language .. ".json")
        loc:load_localization_file(CSHUD.LocPath .. "fun_facts/" .. CSHUD.Language .. ".json")
    end
    if CSHUD.Language ~= "english" or not language_filename then
        loc:load_localization_file(CSHUD.LocPath .. "english.json", false)
        loc:load_localization_file(CSHUD.LocPath .. "fun_facts/english.json", false)
    end
    loc:load_localization_file(CSHUD.LocPath .. "languages.json")
    loc:load_localization_file(CSHUD.LocPath .. "common.json", false)
end)

Hooks:Add("MenuManagerBuildCustomMenus", "MenuManagerBuildCustomMenus_CSHUD", function(menu_manager, nodes)
    MenuCallbackHandler.OpenCSHUDOptions = function(self, item)
        CSHUD.Menu = CSHUD.Menu or CSHUDMenu:new()
		CSHUD.Menu:Open()

        Hooks:PostHook(MenuManager, "update", "update_menu_CSHUD", function(self, t, dt)
            if CSHUD.Menu and CSHUD.Menu.update and CSHUD.Menu._enabled then
                CSHUD.Menu:update(t, dt)
            end
        end)
	end

	local node = nodes["blt_options"]

	local item_params = {
		name = "CSHUD_OpenMenu",
		text_id = "cshud_mod_title",
		help_id = "cshud_mod_desc",
		callback = "OpenCSHUDOptions",
		localize = true,
	}
	local item = node:create_item({type = "CoreMenuItem.Item"}, item_params)
    node:add_item(item)
end)

local _f_toggle_hide_huds = MenuCallbackHandler.toggle_hide_huds
function MenuCallbackHandler:toggle_hide_huds(item, ...)
    _f_toggle_hide_huds(self, item, ...)
	if item:value() == "on" then
		CSHUD._ws:hide()
	else
		CSHUD._ws:show()
	end
end