local original =
{
    at_enter = MissionEndState.at_enter,
    on_statistics_result = MissionEndState.on_statistics_result
}
function MissionEndState:at_enter(old_state, params, ...)
    original.at_enter(self, old_state, params, ...)
    CSHUD._ws:hide()
    if self._success then
        managers.cs_radio:PlayWin()
    else
        managers.cs_radio:PlayLoss()
        CSHUD._cache.mission_failed = true
        local enemy_score = (managers.job:get_memory("CSHUD_EnemyScore") or 0) + 1
        managers.job:set_memory("CSHUD_EnemyScore", enemy_score)
    end
end

function MissionEndState:on_statistics_result(...) -- A lot of parameters
    original.on_statistics_result(self, ...)
    --[[
        Using only first, third, fifth, seventh and tvelweth parameter
        This method only fetches end game results
    ]]
    CSHUD._cache.FunFacts.MostKillsPeerID = select(1, ...) or 0
    CSHUD._cache.FunFacts.MostSpecialKillsPeerID = select(3, ...) or 0
    CSHUD._cache.FunFacts.BestAccuracyPeerID = select(5, ...) or 0
    CSHUD._cache.FunFacts.MostDownedPeerID = select(7, ...) or 0
    CSHUD._cache.FunFacts.GroupAccuracy = select(12, ...) or 0
    CSHUD._cache.success = self._success
    if managers.network and managers.network:session() and CSHUD._cache.MultiPlayer then
        CSHUD._cache.EndGameStats = {}
        CSHUD._cache.EndGameStats_IDs = {}
        local EndGameStats = CSHUD._cache.EndGameStats
        local IDs = CSHUD._cache.EndGameStats_IDs
        for _, peer in pairs(managers.network:session():all_peers()) do
            local stats = peer:statistics()
            if stats then
                local peer_id = peer:id()
                IDs[#IDs + 1] = peer_id
                EndGameStats[peer_id] =
                {
                    name = peer:name(),
                    total_kills = stats.total_kills,
                    total_specials_kills = stats.total_specials_kills,
                    total_head_shots = stats.total_head_shots,
                    accuracy = stats.accuracy,
                    downs = stats.downs
                }
            end
        end
    end
    if CSHUD.IsHost then
        local faction
        if self._success then
            if CSHUD._cache.player_faction == "t" then
                faction = "Terrorists"
            else
                faction = "Counter-Terrorists"
            end
        else
            if CSHUD._cache.enemy_faction == "t" then
                faction = "Terrorists"
            else
                faction = "Counter-Terrorists"
            end
        end
        CSHUD._cache.winning_faction = faction .. " win"
    end
    CSHUD:ShowFunFact()
end