local original =
{
    init_managers = Setup.init_managers,
    init_finalize = Setup.init_finalize,
    destroy = Setup.destroy
}

function Setup:init_managers(managers, ...)
    original.init_managers(self, managers, ...)
    if Global.load_level then
        CSHUD:CreateWorkspace()
        CSHUD:LoadFonts()
        CSHUD:Init()
        if managers.gage_assignment.CreatePanel then
            managers.gage_assignment:CreatePanel()
        end
        managers.cs_radio = CSRadioManager:new()
    end
end

function Setup:init_finalize(...)
    original.init_finalize(self, ...)
    if managers.cs_radio then
        managers.cs_radio:init_finalize()
    end
end

function Setup:destroy(...)
    original.destroy(self, ...)
    CSHUD:DestroyWorkspace()
end