if CSHUD then
    return
end

CSHUD = {
    _cache =
    {
        teammates =
        {
            -- ["character_name"] = {}
        },
        in_custody =
        {
            -- ["character_name"] = panel_id
        },
        FunFacts =
        {
        }
    },

    _hooks = {},

    ListenerEvent =
    {
        SetAI = "SetAI",
        UpdateAvatar = "UpdateAvatar",
        RemovePanel = "RemovePanel"
    },

    listeners =
    {
    },

    Enum =
    {
        Position =
        {
            Condition = 1,
            Top = 2,
            Bottom = 3
        },
        TimeFormat =
        {
            Short = 1,
            Long = 2
        }
    },

    FunFacts =
    {
        InCustodyTimes = {},
        InCustodySpend = {},
        CivilianKills = {},
        Revive = {},
        GagePackages = {}
    },

    ModPath = ModPath,
    AssetsPath = ModPath .. "assets/",
    LocPath = ModPath .. "loc/",
    LuaPath = ModPath .. "lua/",
    MenuPath = ModPath .. "menu/",
    SettingsSaveFilePathOld = BLTModManager.Constants:SavesDirectory() .. "CSGOHUD.json",
    SettingsSaveFilePath = BLTModManager.Constants:SavesDirectory() .. "CSHUD.json",
    Update = false,
    Language = "english",
    SaveDataVer = 1,
    ModVersion = ModInstance and tonumber(ModInstance:GetVersion()) or "N/A",
    dev = false
}

function CSHUD:Init()
    self._cache.level_id = Global.game_settings.level_id
    self._cache.SinglePlayer = Global.game_settings.single_player
    self._cache.MultiPlayer = not self._cache.SinglePlayer
    self.IsHost = Network:is_server()
    self.IsClient = not self.IsHost
    self._cache.assault_mode = "assault"
    local win_faction, loss_faction
    if string.find(self._cache.level_id, "cj_") or self._cache.level_id == "mad" or self._cache.level_id == "bph" then
        win_faction = "ct"
        loss_faction = "t"
    else
        win_faction = "t"
        loss_faction = "ct"
    end
    self._cache.player_faction = win_faction
    self._cache.enemy_faction = loss_faction
    managers.mission:add_global_event_listener("CSHUD_OnPeerRemoved", {
		"on_peer_removed"
    }, callback(self, self, "OnPeerLeft"))
end

function CSHUD:IsCT()
    return self._cache.player_faction == "ct"
end

function CSHUD:IsT()
    return self._cache.player_faction == "t"
end

function CSHUD:PreHook(object, func, pre_call)
    Hooks:PreHook(object, func, "CSHUD_Pre_" .. func, pre_call)
end

function CSHUD:Hook(object, func, post_call)
    Hooks:PostHook(object, func, "CSHUD_" .. func, post_call)
end

function CSHUD:Unhook(mod, id)
    Hooks:RemovePostHook((mod and (mod .. "_") or "CSHUD_") .. id)
end

function CSHUD:DelayCall(name, t, func)
    DelayedCalls:Add(name, t, func)
end

function CSHUD:RemoveDelayedCall(name)
    DelayedCalls:Remove(name)
end

function CSHUD:Load()
    self:LoadDefaultValues()
    local file = io.open(self.SettingsSaveFilePath, "r")
    local file2 = io.open(self.SettingsSaveFilePathOld, "r")
    local valid_file = file or file2
    if valid_file then
        local table
        local success, _ = pcall(function()
            table = json.decode(valid_file:read("*all"))
        end)
        --valid_file:close()
        if success then
            if table.SaveDataVer and table.SaveDataVer == self.SaveDataVer then
                self:LoadValues(self.settings, table)
            else
                self.SaveDataNotCompatible = true
                self:Save()
            end
        else -- Save File got corrupted, use default values
            self.SaveFileCorrupted = true
            self:Save() -- Resave the data
        end
    end
    if file then
        file:close()
    end
    if file2 then
        file2:close()
    end
end

function CSHUD:LoadValues(cs_table, file_table)
    for k, v in pairs(file_table) do -- Load subtables in table and calls the same method to load subtables or values in that subtable
        if type(file_table[k]) == "table" then
            self:LoadValues(cs_table[k], v)
        end
    end
    for k, v in pairs(file_table) do
        if type(file_table[k]) ~= "table" then
            if cs_table[k] ~= nil then -- Load values to the table
                cs_table[k] = v
            end
        end
    end
end

function CSHUD:Save()
    self.settings.SaveDataVer = self.SaveDataVer
    self.settings.ModVersion = self.ModVersion
    local file = io.open(self.SettingsSaveFilePath, "w+")
    if file then
        file:write(json.encode(self.settings) or "{}")
        file:close()
    end
end

function CSHUD:CallEvent(event_name, ...)
    if not event_name then
        self:Log("Event Name cannot be a nil value")
        return
    end
    for _, v in pairs(self.Events) do
        if v.event_name == event_name then
            v.func(...)
        end
    end
end

function CSHUD:GetOption(option)
    if option then
        return self.settings[option]
    end
end

function CSHUD:GetComponentOption(option)
    if option then
        return self.settings.components[option]
    end
end

function CSHUD:GetModOption(mod, option)
    if mod and option then
        return self.settings.mod[mod][option]
    end
end

function CSHUD:GetColorFromTable(value)
    if value and value.r and value.g and value.b then
        return Color(255, value.r, value.g, value.b) / 255
    end
    return Color.white
end

function CSHUD:IsOr(string, ...)
    for i = 1, select("#", ...) do
        if string == select(i, ...) then
            return true
        end
    end
    return false
end

function CSHUD:Log(s, dev)
    if dev then
        if self.dev then
            log("[CS HUD Dev] " .. (s or "nil"))
        end
    else
        log("[CS HUD] " .. (s or "nil"))
    end
end

function CSHUD:LoadFonts()
    local res = managers.dyn_resource
    for _, tbl in pairs(tweak_data.csgo.fonts) do -- Load custom fonts
        local font = tbl.font
        if not res:has_resource(Idstring("font"), Idstring(font), res.DYN_RESOURCES_PACKAGE) then
            res:load(Idstring("font"), Idstring(font), res.DYN_RESOURCES_PACKAGE, nil)
        end
    end
end

function CSHUD:CreateWorkspace()
    self._ws = managers.gui_data:create_fullscreen_workspace()
    self._ws:hide()
end

function CSHUD:CreatePanel(name, layer, hidden)
    if not self._ws then
        self:Log("Cannot create panel because the workspace has not been created yet!")
        return
    end
    local panel = self._ws:panel():panel({
        name = name,
        layer = layer or 1
    })
    if hidden then
        panel:set_visible(false)
    end
    return panel
end

function CSHUD:DestroyWorkspace()
    if alive(self._ws) then
        managers.gui_data:destroy_workspace(self._ws)
        self._ws = nil
        self:Log("Workspace destroyed")
    end
end

function CSHUD:ReturnResXDifferenceAbove1920()
    local x = RenderSettings.resolution.x
    if x and x > 2560 then
        self:Log("Resolution X difference: " .. (x - 2560))
        return x - 2560
    end
    self:Log("Resolution X difference: 0", true)
    return 0
end

function CSHUD:ReturnResYDifferenceAbove1080()
    local y = RenderSettings.resolution.y
    if y and y > 1440 then
        self:Log("Resolution Y difference: " .. (y - 1440))
        return y - 1440
    end
    self:Log("Resolution Y difference: 0", true)
    return 0
end

function CSHUD:AddListener(event, clbk)
    self.listeners[event] = self.listeners[event] or {}
    local events = self.listeners[event]
    events[#events + 1] = clbk
end

function CSHUD:CallListener(event, ...)
    local events = self.listeners[event] or {}
    for _, clbk in ipairs(events) do
        clbk(...)
    end
end

function CSHUD:IsVROrComponentIsDisabled(component)
    if component then
        return _G.IS_VR or not self:GetComponentOption(component)
    end
    return _G.IS_VR
end

function CSHUD:AddTeammate(character_name, params)
    self._cache.teammates[character_name] = params
end

function CSHUD:IsTeammate(character_name)
    return self._cache.teammates[character_name]
end

function CSHUD:GetTeammate(character_name)
    if self._cache.teammates[character_name] then
        return self._cache.teammates[character_name]
    end
    return nil
end

function CSHUD:GetFromTeammate(character_name, param)
    if self._cache.teammates[character_name] then
        return self._cache.teammates[character_name][param]
    end
    return nil
end

function CSHUD:RemoveTeammate(character_name)
    self._cache.teammates[character_name] = nil
end

function CSHUD:PlaceToCustody(character_name)
    if self:IsTeammate(character_name) then
        local teammate_panel = self:GetTeammate(character_name).panel
        self._cache.in_custody[character_name] = teammate_panel
        return teammate_panel
    end
    return 0
end

function CSHUD:RemoveFromCustody(character_name)
    if self._cache.in_custody[character_name] then
        local panel = self._cache.in_custody[character_name]
        self._cache.in_custody[character_name] = nil
        return panel
    end
    return 0
end

function CSHUD:IsManiacPresent()
    for _, value in pairs(self._cache.teammates) do
        if value and value.maniac then
            return true
        end
    end
    return false
end

function CSHUD:IsKillfeedEnabled()
    return self:GetComponentOption("killfeed")
end

function CSHUD:SendMessage(message)
    managers.chat:_receive_message(1, "[CS HUD]", message, Color.white)
    managers.network:session():send_to_peers_ip_verified("send_chat_message", 1, "[CS HUD] " .. message)
end

function CSHUD:ComputeEdgeX(panel_w, panel_x)
    local edge = self:GetOption("hud_edge_position_x")
    local edge_x = (panel_w * (1 - edge)) / 2
    return panel_x + edge_x
end

function CSHUD:ComputeEdgeY(panel_h, panel_y, pos)
    local edge = self:GetOption("hud_edge_position_y")
    local edge_y = (panel_h * (1 - edge)) / 2
    pos = pos or self.Enum.Position.Condition
    if pos == self.Enum.Position.Condition then
        if self:GetOption("avatar_time_panel_position") == 1 then -- Top
            return panel_y + edge_y
        else
            return panel_y - edge_y
        end
    elseif pos == self.Enum.Position.Top then
        return panel_y + edge_y
    else
        return panel_y - edge_y
    end
end

function CSHUD:GetPlayerFaction(modifier)
    if modifier and type(modifier) == "string" then
        return self._cache.player_faction, (self._cache.player_faction .. "_" .. modifier)
    end
    return self._cache.player_faction, nil
end

function CSHUD:FormatTime(time, format, no_zero_s)
    format = format or self.Enum.TimeFormat.Long
    if format == self.Enum.TimeFormat.Short then
        time = math.max(math.floor(time), 0)
        local minutes = math.floor(time / 60)
        time = time - minutes * 60
        local seconds = math.round(time)
        local text = ""
        return text .. (minutes < 10 and "0" .. minutes or minutes) .. ":" .. (seconds < 10 and "0" .. seconds or seconds)
    else
        if time < 60 then -- 1 minute
            if time == 0 and no_zero_s then
                return ""
            end
            local s = ""
            if time ~= 1 then
                s = "s"
            end
            return (math.floor(time) .. " second" .. s)
        elseif time < 3600 then -- 1 hour
            local mins = math.floor(time / 60)
            time = time - (mins * 60) -- Remaining seconds
            local s = ""
            if mins > 1 then
                s = "s"
            end
            if time > 0 then
                s = s .. " "
            end
            return (mins .. " minute" .. s .. self:FormatTime(time, format, true))
        else -- >= 3600
            local hours = math.floor(time / 3600)
            time = time - (hours * 3600)
            local s = ""
            if hours > 1 then
                s = "s"
            end
            if time > 0 then
                s = s .. " "
            end
            return (hours .. " hour" .. s .. self:FormatTime(time, format, true))
        end
    end
end

function CSHUD:OnPeerLeft(peer_id)
    if not peer_id then -- Just in case
        return
    end
    if self.FunFacts.CivilianKills then
        self.FunFacts.CivilianKills[peer_id] = nil
    end
    if self.FunFacts.InCustodyTimes then
        self.FunFacts.InCustodyTimes[peer_id] = nil
    end
    if self.FunFacts.Revive then
        self.FunFacts.Revive[peer_id] = nil
    end
    if self.FunFacts.GagePackages then
        self.FunFacts.GagePackages[peer_id] = nil
    end
end

dofile(CSHUD.LuaPath .. "default_values.lua")
CSHUD:Load()